//------------------------------------------------------
// module  : FunctionGCEBFM.cc
// auteur  : Lazhar Khelifi and Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionGCEBFM.h"


//--------------------------//
//-- Matrice de Flottant ---//
//--------------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de float
//----------------------------------------------------------
float* fmatrix_allocate_1d(int hsize)
 {
  float* matrix;
  matrix=new float[hsize]; return matrix; 
 }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de float
//----------------------------------------------------------
float** fmatrix_allocate_2d(int vsize,int hsize)
 {
  float** matrix;
  float *imptr;

  matrix=new float*[vsize];
  imptr=new  float[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de float
//----------------------------------------------------------
float*** fmatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  float*** matrix;

  matrix=new float**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=fmatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//-----------------------//
//-- Matrice d'entiers --//
//-----------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de int
//----------------------------------------------------------
int* imatrix_allocate_1d(int hsize)
 {
  int* matrix;
  matrix=new int[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de int
//----------------------------------------------------------
int** imatrix_allocate_2d(int vsize,int hsize)
 {
  int** matrix;
  int*  imptr;

  matrix=new int*[vsize];
  imptr=new  int[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de int
//----------------------------------------------------------
int*** imatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  int*** matrix;

  matrix=new int**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=imatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 4d de int
//----------------------------------------------------------
int**** imatrix_allocate_4d(int fsize,int dsize,int vsize,int hsize)
 {
  int**** matrix;

  matrix=new int***[fsize];

  for(int i=0;i<fsize;i++)
    matrix[i]=imatrix_allocate_3d(dsize,vsize,hsize);
  return matrix;
 }

//-----------------------------//
//-- Matrice d'unsigned char --//
//-----------------------------//
//-----------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de unsigned char
//------------------------------------------------------------
unsigned char* cmatrix_allocate_1d(int hsize)
 {
  unsigned char* matrix;
  matrix=new unsigned char[hsize]; return matrix; }

//------------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de unsigned char
//------------------------------------------------------------
unsigned char** cmatrix_allocate_2d(int vsize,int hsize)
 {
  unsigned char** matrix;
  unsigned char*  imptr;

  matrix=new unsigned char*[vsize];
  imptr=new unsigned char[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//------------------------------------------------------------
// alloue de la memoire pour une matrice 3d de unsigned char
//------------------------------------------------------------
unsigned char*** cmatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  unsigned char*** matrix;

  matrix=new unsigned char**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=cmatrix_allocate_2d(vsize,hsize);
  return matrix;
 }


//---------------------------//
//--- Liberation memoire ----//
//---------------------------//
//----------------------------------------------------------
// libere la memoire de la matrice 1d de float
//----------------------------------------------------------
void free_fmatrix_1d(float* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de float
//----------------------------------------------------------
void free_fmatrix_2d(float** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de float
//----------------------------------------------------------
void free_fmatrix_3d(float*** pmat,int dsize)
{
 for(int i=0;i<dsize;i++)
  {
   delete[] (pmat[i][0]);
   delete[] (pmat[i]);
   }
 delete[] (pmat);
}

//----------------------------------------------------------
// libere la memoire de la matrice 1d de int
//----------------------------------------------------------
void free_imatrix_1d(int* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de int
//----------------------------------------------------------
void free_imatrix_2d(int** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de int
//----------------------------------------------------------
void free_imatrix_3d(int*** pmat,int dsize)
{ for(int i=0;i<dsize;i++)
   {
    delete[] (pmat[i][0]);
    delete[] (pmat[i]);
    }
  delete[] (pmat); }

//----------------------------------------------------------
// libere la memoire de la matrice 4d de int
//----------------------------------------------------------
void free_imatrix_4d(int**** pmat,int fsize,int dsize)
{
 for(int i=0;i<fsize;i++)
  free_imatrix_3d(pmat[i],dsize);
  
 delete[] (pmat);
}

//----------------------------------------------------------
// libere la memoire de la matrice 1d de unsigned char
//----------------------------------------------------------
void free_cmatrix_1d(unsigned char* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de unsigned char
//----------------------------------------------------------
void free_cmatrix_2d(unsigned char** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de unsigned char
//----------------------------------------------------------
void free_cmatrix_3d(unsigned char*** pmat,int dsize)
{ for(int i=0;i<dsize;i++)
   {
    delete[] (pmat[i][0]);
    delete[] (pmat[i]);
    }
  delete[] (pmat); }


//--------------------//
//-- Matrix Gestion --//
//--------------------//
//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(int** mat1,int** mat2,int lgth,int wdth)
{
 int i,j;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
  mat1[i][j]=mat2[i][j]; 
}


//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(float** mat1,int** mat2,int lgth,int wdth)
{
 int i,j;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
  mat1[i][j]=mat2[i][j]; 
}

//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(int** mat1,float** mat2,int lgth,int wdth)
{
 int i,j;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat1[i][j]=(int)mat2[i][j]; 
}

//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(unsigned char** mat1,int ** mat2,int lgth,int wdth)
{
 int i,j;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat1[i][j]=(unsigned char)mat2[i][j]; 
}

//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(int** mat1,unsigned char** mat2,int lgth,int wdth)
{
 int i,j;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat1[i][j]=(int)mat2[i][j]; 
}

/*----------------------------------------------------------*/
/* Recal                                                    */
/*----------------------------------------------------------*/
void Recal(float** mat,int lgth,int wdth)
{
 int i,j;
 float max,min;

 /*Initialisation*/
 max=-1000000.0;
 min=100000000;

 /*Recherche du min*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    if (mat[i][j]<min) min=mat[i][j];

 /*plus min*/
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat[i][j]-=min;

 /*Recherche du max*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    if (mat[i][j]>max) max=mat[i][j];

 /*Recalibre la matrice*/
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   if (max) mat[i][j]*=(GREY_LEVEL/max);      
}

/*----------------------------------------------------------*/
/* Recal                                                    */
/*----------------------------------------------------------*/
void Recal(int** mat,int lgth,int wdth)
{
 int i,j;

 //Allocation 
  float** matx=fmatrix_allocate_2d(lgth,wdth);
  
  //Init 
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matx[i][j]=mat[i][j];
  
  //Recal
  Recal(matx,lgth,wdth);

  //Transfert
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]=(int)matx[i][j];

 //Liberation 
 free_fmatrix_2d(matx);

}



//----------------------------------------------------------
// calcule le nombre de differences a chaque iteration
//----------------------------------------------------------
int DiffMatNb(int** pmatl1,int** pmatl2,int lgth,int wdth)
{
 int i,j;
 int chg;

 //>Compte NbChgt
 chg=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (pmatl1[i][j]!=pmatl2[i][j]) chg++; 
       
 return chg;
}


//--------------//
// RANDOM ------//
//--------------//
//----------------------------------------------------------
// retourne un nombre aleatoire entre zero et un
//----------------------------------------------------------
float randomize(void)
{ return ((float)rand()/RAND_MAX); }


//----------//
//-- FILE --//
//----------//
//----------------------------------------------------------
// Get Length and Width
//----------------------------------------------------------
void GetLengthWidth(char* path,int* length,int* width)
{
 unsigned char var;
 int   temp;
 char* tempc;
 char stringTmp1[100];
 char stringTmp2[100];
 int ta1,ta2;
 FILE *fic;

  //ouverture du fichier
  fic=fopen(path,"r");
  if (fic==NULL)
    { printf("\n- Grave erreur a l'ouverture de %s -\n",path);
      exit(-1); }

  //recuperation de l'entete
  tempc=fgets(stringTmp1,100,fic);
  for(;;) { temp=fread(&var,1,1,fic); if (var==35) tempc=fgets(stringTmp2,100,fic);
            else break; }
  fseek(fic,-1,SEEK_CUR);
  temp=fscanf(fic,"%d %d",&ta1,&ta2);
   
  //enregistrement
  (*length)=ta2; 
  (*width)=ta1;

  //fermeture du fichier
  fclose(fic);
}

//----------------------------------------------------------
// Chargement de l'image de nom <name> (en ppm)             
//----------------------------------------------------------
void load_image_ppm(char* path,int*** img,int lgth,int wdth)
 {
  int i,j;
  int temp;
  char* tempc;
  unsigned char varb,varv,varr;

  char stringTmp1[200],stringTmp2[200];
  int ta1,ta2,ta3;
  FILE *fic;

  //enregistrement du chemin;
   if (strstr(path,".ppm")==NULL) strcat(path,".ppm");

   //ouverture du fichier
  fic=fopen(path,"r");
  if (fic==NULL) 
   { printf("\n ->> Grave erreur a l'ouverture de %s -\n",path);
     exit(-1); }

  //recuperation de l'entete
  tempc=fgets(stringTmp1,100,fic); //P6
  tempc=fgets(stringTmp2,100,fic); //Comment

  for(;;)
    { if (((int)stringTmp2[0]==10)||((int)stringTmp2[0]==35))
      tempc=fgets(stringTmp2,100,fic); 

      else break; }

  temp=sscanf(tempc," %d %d",&ta1,&ta2);
  temp=fscanf(fic," %d",&ta3);

  //affichage de l'entete
  //printf("\n\n -- Entete --");
  //printf("\n ------------");
  //printf("\n %s %s %d %d \n %d",stringTmp1,stringTmp2,ta1,ta2,ta3);
  //printf("\n %s  %d %d \n %d",stringTmp1,ta1,ta2,ta3);
  //printf("\n ----------------------------------------------------------\n\n");
   
  //chargement dans la matrice
  for(i=0;i<lgth;i++) for(j=0;j<(wdth*3);j+=3)  
    { temp=fread(&varr,1,1,fic);
      temp=fread(&varv,1,1,fic);
      temp=fread(&varb,1,1,fic);
     
      img[2][i][j/3]=varr;        
      img[0][i][j/3]=varv;        
      img[1][i][j/3]=varb; }      

  //fermeture du fichier
  fclose(fic);
 }

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SaveImagePgm(char* bruit,char* name,float** mat,int lgth,int wdth)
{
 int i,j;
 char buff[300];
 FILE* fic;

  //--extension--
  strcpy(buff,bruit);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
  printf("\n Sauvegarde de %s au format pgm\n",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",wdth,lgth);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
	fprintf(fic,"%c",(char)mat[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 
}

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SaveImagePgm(char* bruit,char* name,int** mat,int lgth,int wdth)
{
 int i,j;
 char buff[300];
 FILE* fic;

  //--extension--
  strcpy(buff,bruit);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
  printf("\n Sauvegarde de %s au format pgm\n",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",wdth,lgth);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
	fprintf(fic,"%c",(char)mat[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 
}

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SaveImagePgm(char* bruit,char* name,unsigned char** mat,int lgth,int wdth)
{
 int i,j;
 char buff[300];
 FILE* fic;

  //--extension--
  strcpy(buff,bruit);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
  printf("\n Sauvegarde de %s au format pgm\n",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",wdth,lgth);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
	fprintf(fic,"%c",(char)mat[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 
}


//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format ppm        
//----------------------------------------------------------
void SaveImagePpm(char* Path_out,char* Name,int*** matrvb,int wdth,int lgth)
 {
  int i,j;
  char buff[200];
  FILE* fuser;

  //extension
  strcpy(buff,Path_out);
  strcat(buff,Name);
  strcat(buff,".ppm");

  //ouverture fichier
  fuser=fopen(buff,"w");
    if (fuser==NULL) 
        { printf(" probleme dans la sauvegarde de %s",buff); 
          exit(-1); }

  //affichage
  printf("\n  >> Sauvegarde dans -> %s au format %s",buff,".ppm");
  fflush(stdout);

  //sauvegarde de l'entete
  fprintf(fuser,"P6");
  fprintf(fuser,"\n# IMG Module");
  fprintf(fuser,"\n%d %d",lgth,wdth);
  fprintf(fuser,"\n255\n");

  //enregistrement
  for(i=0;i<wdth;i++) for(j=0;j<lgth;j++) 
    {
     fprintf(fuser,"%c",(char)matrvb[0][i][j]);
     fprintf(fuser,"%c",(char)matrvb[1][i][j]);
     fprintf(fuser,"%c",(char)matrvb[2][i][j]);
    }
       
  //fermeture fichier
   fclose(fuser); 
 }


//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format ppm        
//----------------------------------------------------------
void SaveImagePpm(char* Path_out,char* Name,float*** matrvb,int wdth,int lgth)
 {
  int i,j;
  char buff[200];
  FILE* fuser;

  //extension
  strcpy(buff,Path_out);
  strcat(buff,Name);
  strcat(buff,".ppm");

  //ouverture fichier
  fuser=fopen(buff,"w");
    if (fuser==NULL) 
        { printf(" probleme dans la sauvegarde de %s",buff); 
          exit(-1); }

  //affichage
  printf("\n  >> Sauvegarde dans -> %s au format %s",buff,".ppm");
  fflush(stdout);

  //sauvegarde de l'entete
  fprintf(fuser,"P6");
  fprintf(fuser,"\n# IMG Module");
  fprintf(fuser,"\n%d %d",lgth,wdth);
  fprintf(fuser,"\n255\n");

  //enregistrement
  for(i=0;i<wdth;i++) for(j=0;j<lgth;j++) 
    {
     fprintf(fuser,"%c",(char)matrvb[0][i][j]);
     fprintf(fuser,"%c",(char)matrvb[1][i][j]);
     fprintf(fuser,"%c",(char)matrvb[2][i][j]);
    }
       
  //fermeture fichier
   fclose(fuser); 
 }

//----------------------------------------------------------
// Sauvegarde du Tab. d''image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SaveTabImagePgm(char* path,char* name,int*** mat,int lgth,int wdth,int nb)
{
  int i,j,k,l;
 char buff[300];
 FILE* fic;
 float NbPic;
 int   LgthNb,WdthNb;
 int nbimg;

  //--extension--
  strcpy(buff,path);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--Memory---
  NbPic=(int)((sqrt(nb)-0.1)+1.0);
  LgthNb=lgth*(int)NbPic;
  WdthNb=wdth*(int)NbPic;
  //printf("\n [<%d>]",(int)NbPic);
  float** MatImg=fmatrix_allocate_2d(LgthNb,WdthNb);

  //--Load--
  for(i=0;i<LgthNb;i++) for(j=0;j<WdthNb;j++) MatImg[i][j]=0.0;

  nbimg=-1;
  for(k=0;k<(int)NbPic;k++) for(l=0;l<(int)NbPic;l++)
     { nbimg++;
       if (nbimg>(nb-1)) break;
       for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
         MatImg[(k*lgth)+i][(l*wdth)+j]=mat[nbimg][i][j]; }

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
  printf("\n  >> Sauvegarde de %s au format pgm",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",WdthNb,LgthNb);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<LgthNb;i++) for(j=0;j<WdthNb;j++) 
	fprintf(fic,"%c",(char)MatImg[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 

  //Liberation Memoire
  if (MatImg) free_fmatrix_2d(MatImg);

}

//--------------------
//-- SPACE COLOR -----
//--------------------
//----------------------------------------------------------*/
// RGBToHSV 
// --------
// H=[0::360]   S=[0::1]  V=[0::255]
//                        
//----------------------------------------------------------*/
void RGBToHSV(float r,float g,float b,float* h,float* s,float* v)
{
 float maxRGB=MAX(MAX(r,g),MAX(g,b));
 float minRGB=MIN(MIN(r,g),MIN(g,b));

 (*v)=maxRGB;                                                

 if (maxRGB==0)   (*s)=0.0;
 else             (*s)= (maxRGB-minRGB)/maxRGB;                    

        
 if ((*s)==0)     (*h)=0.0;                                              
 else
    { if (r==maxRGB)       (*h)=(g-b)/(maxRGB-minRGB);    
      else if (g==maxRGB)  (*h)=2+(b-r)/(maxRGB-minRGB);
      else                 (*h)=4+(r-g)/(maxRGB-minRGB);

      (*h)*=60;           
      if ((*h)<0.0)        (*h)+=360;  }
}

//----------------------------------------------------------*/
// RGBToYIQ  
//
//  |Y|  |0.299   0.587   0.114| |R|
//  |I|= |0.596  -0.275  -0.321| |G|
//  |Q|  |0.212  -0.523   0.311| |B|
//
//  Y=[0::1]
//  I=[-0.5957161349127745527::0.5957161349127745527]
//  Q=[-0.5225910452916111684::0.5225910452916111684]
//                   
//----------------------------------------------------------*/
void RGBToYIQ(float r,float g,float b,float* y,float* i,float* q)
{
  //RGB en [0-1]
  r/=255.0;
  g/=255.0;
  b/=255.0;

  //Conversion
 (*y)=(0.299*r)+(0.587*g) +(0.114*b);
 (*i)=(0.596*r)+(-0.275*g)+(-0.321*b);
 (*q)=(0.212*r)+(-0.523*g)+(0.311*b);

 //Result
 if (0)
    {
      (*y)*=255.0;
      (*i)=(((*i)+0.6)/1.20)*255.0;
      (*q)=(((*q)+0.6)/1.20)*255.0; 
    }
}

//----------------------------------------------------------*/
// RGBToXYZ  
//
//   [ X ]   [  0.412453  0.357580  0.180423 ] [ R ] 
//   [ Y ] = [  0.212671  0.715160  0.072169 ] [ G ]
//   [ Z ]   [  0.019334  0.119193  0.950227 ] [ B ].
//
// [X,Y,Z] = [0::255]
//                   
//----------------------------------------------------------*/
void RGBToXYZ(float r,float g,float b,float* x,float* y,float* z)
{
  //RGB en [0-1]
  r/=255.0;
  g/=255.0;
  b/=255.0;

  //Conversion
 (*x)=(0.412453*r)+(0.357580*g)+(0.180423*b);
 (*y)=(0.212671*r)+(0.715160*g)+(0.072169*b);
 (*z)=(0.019334*r)+(0.119193*g)+(0.950227*b);

  //RGB 
 (*x)*=255.0;
 (*y)*=255.0;
 (*z)*=255.0;

  //Tests
 if ((*x)>255)  (*x)=255;
 if ((*x)<0)    (*x)=0;

 if ((*y)>255)  (*y)=255;
 if ((*y)<0)    (*y)=0;

 if ((*z)>255)  (*z)=255;
 if ((*z)<0)    (*z)=0;
}

//----------------------------------------------------------*/
//  XYZtoRGB 
//
//   [ R ]   [  3.240479 -1.537150 -0.498535 ] [ X ]
//   [ G ] = [ -0.969256  1.875992  0.041556 ] [ Y ]
//   [ B ]   [  0.055648 -0.204043  1.057311 ] [ Z ].
//
// [R,G,B] = [0::255]
//                   
//----------------------------------------------------------*/
void XYZToRGB(float x,float y,float z,float* r,float* g,float* b)
{
  //XYZ en [0-1]
  x/=255.0;
  y/=255.0;
  z/=255.0;

  //Conversion
 (*r)=(3.240479*x)+(-1.537150*y)+(-0.498535*z);
 (*g)=(-0.969256*x)+(1.875992*y)+(0.041556*z);
 (*b)=(0.055648*x)+(-0.204043*y)+(1.057311*z);

 //RGB en [0-255]
 (*r)*=255.0;
 (*g)*=255.0;
 (*b)*=255.0;

 //Tests
 if ((*r)>255)  (*r)=255;
 if ((*r)<0)    (*r)=0;

 if ((*g)>255)  (*g)=255;
 if ((*g)<0)    (*g)=0;

 if ((*b)>255)  (*b)=255;
 if ((*b)<0)    (*b)=0;
}

//----------------------------------------------------------*/
// RGBToLAB  
//
// LAB = [0::100][-85::110][0::255]
//
//
//        L* = 116 * (Y/Yn)1/3 - 16    for Y/Yn > 0.008856
//        L* = 903.3 * Y/Yn             otherwise
//
//        a* = 500 * ( f(X/Xn) - f(Y/Yn) )
//        b* = 200 * ( f(Y/Yn) - f(Z/Zn) )
//            where f(t) = t1/3      for t > 0.008856
//                      f(t) = 7.787 * t + 16/116    otherwise
//                   
//----------------------------------------------------------*/
void RGBToLAB(float r,float g,float bl,float* l,float* a,float* b)
{
 float x,y,z;
 float xn,yn,zn;

 //RGB en [0-1]
  r/=255.0;
  g/=255.0;
  bl/=255.0;

 //Conversion RGB->XYZ
  RGBToXYZ(r,g,bl,&x,&y,&z);
  RGBToXYZ(1.0,1.0,1.0,&xn,&yn,&zn);

 //Conversion XYZ->LAB
  if ((y/yn)>0.008856)  (*l)=116.0*pow((y/yn),(1.0/3.0))-16.0;
  else                  (*l)=903.3*(y/yn);

  if ((x/xn)>0.008856)  (*a)=500.0*(pow((x/xn),(1.0/3.0)));
  else                  (*a)=7.787*(x/xn)+16.0/116.0;

  if ((y/yn)>0.008856)  (*a)-=500.0*(pow((y/yn),(1.0/3.0)));
  else                  (*a)-=7.787*(y/yn)+16.0/116.0;

  if ((y/yn)>0.008856)  (*b)=500.0*(pow((y/yn),(1.0/3.0)));
  else                  (*b)=7.787*(y/yn)+16.0/116.0;

  if ((z/zn)>0.008856)  (*b)-=500.0*(pow((z/zn),(1.0/3.0)));
  else                  (*b)-=7.787*(z/zn)+16.0/116.0;
}

//----------------------------------------------------------*/
// RGBToLUV  
//
// LUV = [0::100][-86::164][-131::116]
//  
//        L* =  116 * (Y/Yn)1/3 - 16
//        u* =  13L* * ( u' - un' )
//        v* =  13L* * ( v' - vn' )
//
//      un' = 0.2009 
//      vn' = 0.4610 
//
//        u' = 4X / (X + 15Y + 3Z) = 4x / ( -2x + 12y + 3 )
//        v' = 9Y / (X + 15Y + 3Z) = 9y / ( -2x + 12y + 3 ).
//
//       x = 27u' / ( 18u' - 48v' + 36 )
//       y = 12v' / ( 18u' - 48v' + 36 ).
//               
//----------------------------------------------------------*/
void RGBToLUV(float r,float g,float bl,float* l,float* u,float* v)
{
 float x,y,z;
 float xn,yn,zn;
 float uprime,vprime;

 //Init
 uprime=0.0;
 vprime=0.0;

 //RGB en [0-1]
  r/=255.0;
  g/=255.0;
  bl/=255.0;

 //Conversion RGB->XYZ
  RGBToXYZ(r,g,bl,&x,&y,&z);
  RGBToXYZ(1.0,1.0,1.0,&xn,&yn,&zn);

  //Calcul uprime/vprime
  if (x+(15*y)+(3*z))
   { uprime=(4*x)/(x+(15*y)+(3*z));
     vprime=(9*y)/(x+(15*y)+(3*z)); }

 //Conversion XYZ->LUV
 (*l)=116.0*pow((y/yn),(1.0/3.0))-16.0;
 (*u)=13*(*l)*(uprime-0.2009);
 (*v)=13*(*l)*(vprime-0.4610);
}

//----------------------------------------------------------*/
// LUVToRGB  
//
//  u' = u / ( 13L*) + un
//  v' = v / ( 13L* ) + vn
//  Y = (( L* + 16 ) / 116 )3
//  X = - 9Yu' / (( u' - 4 ) v' - u'v' )
//  Z = ( 9Y - 15v'Y - v'X ) / 3v' 
//
//      un' = 0.2009 
//      vn' = 0.4610 
//                   
//----------------------------------------------------------*/
void LUVToRGB(float l,float u,float v,float* r,float* g,float* bl)
{
 float x,y,z;
 float uprime,vprime;

 //Conversion LUV->XYZ
 uprime=u/(13*l)+0.2009;
 vprime=v/(13*l)+0.4610;
 
 y=pow(((l+16)/116),3.0);
 x=-9*y*uprime/(((uprime-4)*vprime)-uprime*vprime);
 z=((9*y-15*vprime*y-vprime*x)/(3*vprime));

 //Conversion XYZ->RGB
 XYZToRGB(x,y,z,r,g,bl);

 //RGB en [0-255]
 (*r)*=255.0;
 (*g)*=255.0;
 (*bl)*=255.0;

 //Tests
 if ((*r)>255)  (*r)=255;
 if ((*r)<0)    (*r)=0;

 if ((*g)>255)  (*g)=255;
 if ((*g)<0)    (*g)=0;

 if ((*bl)>255)  (*bl)=255;
 if ((*bl)<0)    (*bl)=0;
}

//----------------------------------------------------------*/
// RGBToI1I2I3  
//
// I1=(1/3) (R+G+B)
// I2=(R-B)
// I3=(2G-R-B)/2
//                   
//----------------------------------------------------------*/
void RGBToI1I2I3(float r,float g,float bl,float* i1,float* i2,float* i3)
{

  //Conversion RGB -> I1I2I3
  (*i1)=(1.0/3.0)*(r+g+bl);
  (*i2)=(r-bl);
  (*i3)=((1.0/2.0)*(2*g-r-bl));
}

//----------------------------------------------------------*/
// RGBToH1H2H3  
//
// H1= R+G
// H2= R-G
// H3= B- (1.0/2.0)(R+G)
//                   
//----------------------------------------------------------*/
void RGBToH1H2H3(float r,float g,float bl,float* h1,float* h2,float* h3)
{

  //Conversion RGB -> H1H2H3
  (*h1)=(r+g);
  (*h2)=(r-g);
  (*h3)=(bl-(1.0/2.0)*(r+g));
}

//----------------------------------------------------------*/
// RGBToTSL
//
// rp=r-(1.0/3.0);
// gp=g-(1.0/3.0);
//
//  L=(1.0/2.0)* [MAX(r,g,b)+MIN(r,g,bl)] 
//
//  Si  (gp>0)  T=((1.0/(2*PI))*atan(rp/gp))+0.25
//  Si  (gp<0)  T=((1.0/(2*PI))*atan(rp/gp))+0.75
//  Si  (!gp)   T=0.0
//
//  S=sqrt[ (9.0/5.0) (rp^2 +gp^2) ]
//                   
//----------------------------------------------------------*/
void RGBToTSL(float r,float g,float bl,float* t,float* s,float* l)
{

 float rp,gp;
 
 //RGB en [0-1]
 r/=255.0;
 g/=255.0;
 bl/=255.0;

 //r/gprime
 rp=r-(1.0/3.0);
 gp=g-(1.0/3.0);

 //min/maxRGB
 float maxRGB=MAX(MAX(r,g),MAX(g,bl));
 float minRGB=MIN(MIN(r,g),MIN(g,bl));

 //Conversion RGB -> HSV
 (*l)=(1.0/2.0)*(maxRGB+minRGB);

 if (gp>0)  (*t)=((1.0/(2*PI))*atan(rp/gp))+0.25;
 if (gp<0)  (*t)=((1.0/(2*PI))*atan(rp/gp))+0.75;
 if (!gp)   (*t)=0.0;
 if (*t<0)  (*t)=0.0;

 (*s)=sqrt((9.0/5.0)*(CARRE(rp)+CARRE(gp)));
}

//----------------------------------------------------------*/
// RGBToYCbCr
//
//  Y=(0.2989*r)+(0.5866*g)+(0.1145*bl);
//  Cb=(bl-Y)/(2-2*0.1145);
//  Cr=(r-Y)/(2-2*0.2989);
//
//                   
//----------------------------------------------------------*/
void RGBToYCbCr(float r,float g,float bl,float* Y,float* Cb,float* Cr)
{  
 //Conversion RGB -> YCbCr
 (*Y)=(0.2989*r)+(0.5866*g)+(0.1145*bl);
 (*Cb)=(bl-(*Y))/(2-2*0.1145);
 (*Cr)=(r-(*Y))/(2-2*0.2989);
}

//----------------------------------------------------------*/
// RGBToHSL
//
//  H=ACOS[ 0.5(r-g)+(r-b)) / sqrt[ (r-g)^2=(r-b)*(g-b) ] ]
// 
//  L=(1.0/2.0)* [MAX(r,g,b)+MIN(r,g,bl)] 
//
// if (l<=0.5) S=MAX(r,g,b)-MIN(r,g,b)/(MAX(r,g,b)+MIN(r,g,b))
// if (l>0.5)  S=MAX(r,g,b)-MIN(r,g,b)/(2-(MAX(r,g,b)+MIN(r,g,b)))
//                   
//----------------------------------------------------------*/
void RGBToHSL(float r,float g,float bl,float* h,float* s,float* l)
{
 float tmp1,tmp2;

 //RGB en [0-1]
 r/=255.0;
 g/=255.0;
 bl/=255.0;

 //min/maxRGB
 float maxRGB=MAX(MAX(r,g),MAX(g,bl));
 float minRGB=MIN(MIN(r,g),MIN(g,bl));

 //Conversion RGB -> HSV
 tmp1=(0.5)*((r-g)+(r-bl));
 tmp2=sqrt((CARRE(r-g))+(r-bl)*(g-bl));
 if (tmp2) (*h)=acos(tmp1/tmp2);
 else      (*h)=0.0;
 
 (*l)=(1.0/2.0)*(maxRGB+minRGB);

  (*s)=0.0;
  if ((*l)<=0.5) if(maxRGB+minRGB) (*s)=(maxRGB-minRGB)/(maxRGB+minRGB);
  if ((*l)>0.5)  (*s)=(maxRGB-minRGB)/(2.0-(maxRGB+minRGB));

 if isnan(*(h)) *h=0.0;
 if isnan(*(s)) *s=0.0;
 if isnan(*(l)) *l=0.0;  
}

//----------------------------------------------------------*/
// RGBToP1P2
//
//  P1=(1.0/sqrt(2))*(g-r)/sumRGB;
//  P2=(1.0/sqrt(6))*(2*bl-r-g)/sumRGB;
//
//                   
//----------------------------------------------------------*/
void RGBToP1P2(float r,float g,float bl,float* P1,float* P2,float* P3)
{  
 float sumRGB=(r+g+bl);

 //Init
 (*P1)=0.0;
 (*P2)=0.0;

 //Conversion RGB -> P1P2
 if (sumRGB) (*P1)=(1.0/sqrt(2.0))*(g-r)/sumRGB;
 if (sumRGB) (*P2)=(1.0/sqrt(6.0))*(2*bl-r-g)/sumRGB;
 (*P3)=0.0;

 //Verif
 if isnan(*P1) (*P1)=0.0;
 if isnan(*P2) (*P2)=0.0;
}

//---------------
//---K-MEAN------
//---------------
//----------------------------------------------------------
// Identical                      
//----------------------------------------------------------
int Identical(int* VctPts,int** MtxCtrs,int nbcl,int nbpar)
{
 int k,l;
 int value=0;

 for(k=0;k<nbcl;k++) 
   { value=1;
     for(l=0;l<nbpar;l++) if (VctPts[l]!=MtxCtrs[k][l]) value=0;
     if (value) return value; }
    
 return value;
}

//----------------------------------------------------------
//  K-Mean  
//    Avec Entiers
//----------------------------------------------------------
void KmeanFast(int** MatrixPts,int NbClusters,int NbPts,int NbParam,int* VctLabel,int Seed,int FlgMan)
{
 int i,j,k,l;
 int classe;
 float aleat;
 int nb;
 float  dist,distmin;
 int flag;
 
 //Allocation memoire
 int** MatrixCtrs=imatrix_allocate_2d(NbClusters,NbParam);
 
 //Presentation
 //printf("\n  <Seed:%d> -> Funct.Kmean",Seed);
 srand(Seed);
 //if (FlgMan) printf("\n  K-Moy > [Dist. Manhattan]"); 


 //--------------------------------------------------------------
 // -[0]- Initialize Centroid
 // --------------------------------------------------------------
  if (0)                    
  for(i=0;i<NbClusters;i++) 
     { aleat=(i+1)*(NbPts/(NbClusters+2));
       for(k=0;k<NbParam;k++) MatrixCtrs[i][k]=MatrixPts[(int)aleat][k]; } 

  if (1)
  for(i=0;i<NbClusters;i++) 
   { nb=0;
     do { aleat=(int)((randomize())*NbPts-1); nb++; }
     while((i)&&(nb<100)&&(Identical(MatrixPts[(int)aleat],MatrixCtrs,NbClusters,NbParam)));

     //if (nb>1) printf(" <|%d Essais|>",nb);

     for(k=0;k<NbParam;k++) MatrixCtrs[i][k]=MatrixPts[(int)aleat][k]; } 
  //------------------------------------------------------------------
  //------------------------------------------------------------------
    
 
  //printf("\n    ");
 //================================================================
 //BOUCLE =========================================================
 //================================================================
 for(l=0;l<50;l++)
   {  
       //-[1]- Select Cluster Membership
       //-------------------------------
       flag=0; classe=0;

       for(j=0;j<NbPts;j++)
          { distmin=BIGNUMBER;  

           for(i=0;i<NbClusters;i++)
              { dist=0.0; 
                
                //Euclidean distance
                if (!FlgMan)
                for(k=0;k<NbParam;k++) dist+=CARRE(MatrixCtrs[i][k]-MatrixPts[j][k]);

                //Manhattan distance
		if (FlgMan)
                for(k=0;k<NbParam;k++) dist+=abs(MatrixCtrs[i][k]-MatrixPts[j][k]);
		     
                if (dist<distmin) { distmin=dist; classe=i; }
	      }            
           if (VctLabel[j]!=classe) { VctLabel[j]=classe; flag++; }
	  }

       //-[2]- Stop Criterion & Info
       //---------------------------
       if ((!flag)&&(l>2))  break;
       //printf("[%d>%d]",l,flag); fflush(stdout);
          
       
       //-[3]- Update Centroids For Each Clusters
       //----------------------------------------
        for(i=0;i<NbClusters;i++) 
	  {  
           nb=0;    
	   for(k=0;k<NbParam;k++) MatrixCtrs[i][k]=0;
                      
	   for(j=0;j<NbPts;j++) if (VctLabel[j]==i)
	      { nb++;
                for(k=0;k<NbParam;k++) MatrixCtrs[i][k]+=MatrixPts[j][k]; }

           for(k=0;k<NbParam;k++) if (nb) MatrixCtrs[i][k]/=nb;
          }

   }//==============================================================
 //================================================================= 

 //FreeMemory
 if (MatrixCtrs) free_imatrix_2d(MatrixCtrs);
}

//----------------------------
//----<HISTO><COLOR-BASE>-----
//----------------------------
//----------------------------------------------------------
//  Segmentation <Histo-COLOR-> Kmean
//
//  image[lgth][wdth] 
//     NbClass / Histo divise en <div> bin with SizeWindow: <SzW>
// 
//  COLbase::
//  -----------            
//  -0- RGB ->    [X,Y,Z] = [0,255]
//  -1- HSV ->    H=[0::360]  S=[0::1]   V=[0::255]
//  -2- YIQ -     Y=[0::1]    I=[-0.55::0.55]  Q=[-0.4::0.4]
//  -3- XYZ ->    [X,Y,Z] = [0,255]
//  -4- LAB -     L=[0::100]    A=[-128::143]  B=[-258::237]
//  -5- LUV -     L=[-16::100]  U=[-60::145]   V=[-130::117]    
//  -6- i123-     i1=[0::255]    i2=[-255::255]      i3=[-255::255]  
//  -7- h123-     h1=[0::510]    h2=[-255::255]      h3=[-255::255]
//  -8- YCbCr    Y=[0::255]     Cb=[-127.5::127.5]  Cr=[-127.5::127.5]
//  -9- TSL-      T=[0::1]       S=[0::1.265]        L=[0::1]
//  -10-HSL-      H=[0::3.142]   S=[0::1]            L=[0::1]    
//  -11- P1P2     P1=[-0.707::0.707]   P2=[-0.408::0.816]   
//
//  Recalage sur [0-255] avec :: (C-min)*255/(max-min)
//
//----------------------------------------------------------     
//----------------------------------------------------------     
// SegmentationHistoCOLORKmean Avec Entier 
//----------------------------------------------------------     
void SegmentationHistoCOLORKmeanFast(int*** img,int** matout,int lgth,int wdth,int NbClass,int div,int SzW,int Seed,int bascol)
{
 int i,j,k,l;
 int nbpts; 
 int posr,posc;
 float divis;
 float lab;
 float col1,col2,col3;

 //Init
 int NbParam=div*div*div; 
 divis=(256.0/(float)div);  
 
 //Initialisatio memoire
 int** PtsTab=imatrix_allocate_2d(lgth*wdth,NbParam);
 float*** SquWin=fmatrix_allocate_3d(3,SzW,SzW);
 float*** ImgColorSpace=fmatrix_allocate_3d(3,lgth,wdth);
 int*  TabLabel=imatrix_allocate_1d(NbParam);
 int* VctLabel=imatrix_allocate_1d(lgth*wdth);  

 //Presentation
 if (0)
   { printf("\n   >>> SegHisto-COLOR-Kmean");
     printf("[NbCl:%d][Div:%d][Ws:%d][Col:%d][Par:%d]",NbClass,div,SzW,bascol,NbParam); 
     if (bascol==0)  printf(" >RGB");
     if (bascol==1)  printf(" >HSV");
     if (bascol==2)  printf(" >YIQ");
     if (bascol==3)  printf(" >XYZ");
     if (bascol==4)  printf(" >LAB");
     if (bascol==5)  printf(" >LUV");
     if (bascol==6)  printf(" >I1I2I3");
     if (bascol==7)  printf(" >H1H2H3");
     if (bascol==8)  printf(" >YCbCr");
     if (bascol==9)  printf(" >TSL");
     if (bascol==10) printf(" >HSL"); 
     if (bascol==11) printf(" >P1P2"); 
     fflush(stdout); }
 
 //-------------------------------------------------------------------------
 //Conversion
 //-------------------------------------------------------------------------
 if ((bascol%12)==0)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { ImgColorSpace[0][i][j]=img[0][i][j];
      ImgColorSpace[1][i][j]=img[1][i][j];
      ImgColorSpace[2][i][j]=img[2][i][j]; }

 if ((bascol%12)==1)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToHSV(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3); 
      ImgColorSpace[0][i][j]=(col1/360.0)*255.0;
      ImgColorSpace[1][i][j]=col2*255.0;
      ImgColorSpace[2][i][j]=col3; }

 if ((bascol%12)==2)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToYIQ(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3); 
      ImgColorSpace[0][i][j]=col1*255.0;
      ImgColorSpace[1][i][j]=((col2+0.55)/1.10)*255.0;
      ImgColorSpace[2][i][j]=((col3+0.4)/0.8)*255.0; }

 if ((bascol%12)==3)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToXYZ(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=col1;
      ImgColorSpace[1][i][j]=col2;
      ImgColorSpace[2][i][j]=col3; }

 if ((bascol%12)==4)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToLAB(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=col1*2.55;
      ImgColorSpace[1][i][j]=((col2+128)/271.0)*255.0;
      ImgColorSpace[2][i][j]=((col3+258)/495.0)*255.0; }

 if ((bascol%12)==5)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
   {  RGBToLUV(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=((col1+16)/250.0)*255.0;
      ImgColorSpace[1][i][j]=((col2+60)/205.0)*255.0;
      ImgColorSpace[2][i][j]=((col3+130)/247.0)*255.0; }

 if ((bascol%12)==6)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToI1I2I3(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=col1;
      ImgColorSpace[1][i][j]=((col2+255)/2.0);
      ImgColorSpace[2][i][j]=((col3+255)/2.0);  }

 if ((bascol%12)==7)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToH1H2H3(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=col1/2.0; 
      ImgColorSpace[1][i][j]=((col2+255)/2.0); 
      ImgColorSpace[2][i][j]=((col3+255)/2.0); }

 if ((bascol%12)==8)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToYCbCr(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=col1; 
      ImgColorSpace[1][i][j]=col2+127.5; 
      ImgColorSpace[2][i][j]=col3+127.5; }

 if ((bascol%12)==9)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToTSL(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=col1*255;
      ImgColorSpace[1][i][j]=255*col2/1.265; 
      ImgColorSpace[2][i][j]=col3*255;  }

 if ((bascol%12)==10)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToHSL(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=255*col1/3.142;  
      ImgColorSpace[1][i][j]=col2*254;
      ImgColorSpace[2][i][j]=col3*255; }

 if ((bascol%12)==11)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { RGBToP1P2(img[0][i][j],img[1][i][j],img[2][i][j],&col1,&col2,&col3);
      ImgColorSpace[0][i][j]=(col1+0.707)*255.0/1.414; 
      ImgColorSpace[1][i][j]=(col2+0.408)*255.0/1.224; 
      ImgColorSpace[2][i][j]=0.0; }


 //Debug
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
   { if (ImgColorSpace[0][i][j]>255)  ImgColorSpace[0][i][j]=255.0;
     if (ImgColorSpace[1][i][j]>255)  ImgColorSpace[1][i][j]=255.0;
     if (ImgColorSpace[2][i][j]>255)  ImgColorSpace[2][i][j]=255.0;
     if (ImgColorSpace[0][i][j]<0)    ImgColorSpace[0][i][j]=0.0;
     if (ImgColorSpace[1][i][j]<0)    ImgColorSpace[1][i][j]=0.0;
     if (ImgColorSpace[2][i][j]<0)    ImgColorSpace[2][i][j]=0.0; }
 //-------------------------------------------------------------------------- 
  

 //---------------------------------------------------------------
 //Data   
 //----------------------------------------------------------------                       
 nbpts=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
    {
     for(k=0;k<SzW;k++) for(l=0;l<SzW;l++) 
        { 
	 posr=i-(SzW/2)+k;
         posc=j-(SzW/2)+l;

         if (posr<0)           posr+=lgth;
         if (posr>(lgth-1))    posr-=lgth;  
         if (posc<0)           posc+=wdth;
         if (posc>(wdth-1))    posc-=wdth;
        
         SquWin[0][k][l]=ImgColorSpace[0][posr][posc];
         SquWin[1][k][l]=ImgColorSpace[1][posr][posc];
         SquWin[2][k][l]=ImgColorSpace[2][posr][posc];  
        }

     //DataStructure
     for(k=0;k<NbParam;k++)  TabLabel[k]=0;
      
     for(k=0;k<SzW;k++) for(l=0;l<SzW;l++)  
	{ lab=((int)(SquWin[0][k][l]/divis))*(div*div);
          lab+=((int)(SquWin[1][k][l]/divis))*(div);  
          lab+=((int)(SquWin[2][k][l]/divis));  
          TabLabel[(int)(lab)]++; }
    
     for(k=0;k<NbParam;k++)    PtsTab[nbpts][k]=TabLabel[k];

     nbpts++;     
    }//----------------------------------------------------------------

 //K-Mean    
 KmeanFast(PtsTab,NbClass,(lgth*wdth),NbParam,VctLabel,Seed,1);
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  matout[i][j]=VctLabel[(i*wdth)+j];    

 //Liberation Memoire
 if (PtsTab)         free_imatrix_2d(PtsTab);
 if (SquWin)         free_fmatrix_3d(SquWin,3);
 if (TabLabel)       free_imatrix_1d(TabLabel);
 if (VctLabel)       free_imatrix_1d(VctLabel);
 if (ImgColorSpace)  free_fmatrix_3d(ImgColorSpace,3);
}

//----------------
//  FUSION -------
//----------------
//----------------------------------------------------------
// Paint        
//----------------------------------------------------------
void Paint(int** mat,int** mattmp,int row,int col,int lgth,int wdth,int lab)
{
   if ((mattmp[row][col]==0)&&(mat[row][col]==lab))
    { 
     mattmp[row][col]=-1;
     
     if ((col+1)<=(wdth-1))   Paint(mat,mattmp,row,col+1,lgth,wdth,lab);
     if ((col-1)>=0)          Paint(mat,mattmp,row,col-1,lgth,wdth,lab);
     if ((row+1)<=(lgth-1))   Paint(mat,mattmp,row+1,col,lgth,wdth,lab);
     if ((row-1)>=0)          Paint(mat,mattmp,row-1,col,lgth,wdth,lab); 
     }

 else return;
}

//----------------------------------------------------------
// Paint        
//----------------------------------------------------------
void Paint(float** mat,int** mattmp,int row,int col,int lgth,int wdth,int lab)
{
 if ((mattmp[row][col]==0)&&(mat[row][col]==lab))
    { 
     mattmp[row][col]=-1;

     if ((col+1)<=(wdth-1))  Paint(mat,mattmp,row,col+1,lgth,wdth,lab);
     if ((col-1)>=0)         Paint(mat,mattmp,row,col-1,lgth,wdth,lab);
     if ((row+1)<=(lgth-1))  Paint(mat,mattmp,row+1,col,lgth,wdth,lab);
     if ((row-1)>=0)         Paint(mat,mattmp,row-1,col,lgth,wdth,lab); 
     }

 else return;
}

//----------------------------------------------------------
// Paint
//----------------------------------------------------------
void Paint(float** mat,float** mattmp,int row,int col,int lgth,int wdth,int lab)
{
   if ((mattmp[row][col]==0)&&(mat[row][col]==lab))
    {
     mattmp[row][col]=-1;

     if ((col+1)<=(wdth-1))   Paint(mat,mattmp,row,col+1,lgth,wdth,lab);
     if ((col-1)>=0)          Paint(mat,mattmp,row,col-1,lgth,wdth,lab);
     if ((row+1)<=(lgth-1))   Paint(mat,mattmp,row+1,col,lgth,wdth,lab);
     if ((row-1)>=0)          Paint(mat,mattmp,row-1,col,lgth,wdth,lab);
     }

 else return;
}

//----------------------------------------------------------
// Convert <ClassRegion>              
//----------------------------------------------------------
void ConvertClassRegion(float** mat,int lgth,int wdth)
{
 int i,j,k,l,m;
 int label;
 float coul;
 int nb;
 int cpt;
 
  //Allocation 
  int** mattmp=imatrix_allocate_2d(lgth,wdth);
  int*  TabGrey=imatrix_allocate_1d(256);
  
  //Init 
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[i][j]=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]=(int)mat[i][j];
  for(i=0;i<256;i++)  TabGrey[i]=0;

  //Check
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
     if ((mat[i][j]>=0)&&(mat[i][j]<256)) TabGrey[int(mat[i][j])]++;

   for(nb=0,i=0;i<256;i++)  if (TabGrey[i]) nb++;
   printf("\n >> NbClasses [%d]",nb);
   fflush(stdout);
   for(i=0;i<256;i++)  TabGrey[i]=0; 

  //Boucle
  //-------
  cpt=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     if (mattmp[i][j]==0)
        {
	 label=(int)mat[i][j];
         //printf("[^^^^%d-%d(%d)^^^^]",i,j,(int)label);

         Paint(mat,mattmp,i,j,lgth,wdth,label);

         do 
           { coul=(int)(randomize()*255); }
         while (TabGrey[(int)coul]);

         TabGrey[(int)coul]=1;
         ++cpt;
         
         if (cpt>=255)
	    { for(m=0;m<256;m++)  TabGrey[m]=0;
              cpt=0; printf("*Regions debordent*"); }        

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++)
	   if (mattmp[k][l]==-1) mat[k][l]=(int)coul;

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++)
	   if (mattmp[k][l]==-1) mattmp[k][l]=-2;
        }
 
   //Compte Regions
   for(i=0;i<256;i++)  TabGrey[i]=0;
      
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) TabGrey[int(mat[i][j])]++;

   for(nb=0,i=0;i<256;i++)  if (TabGrey[i]) nb++;
       printf(" :: NbRegions [%d]",nb);
   fflush(stdout);

 //Liberation 
 free_imatrix_2d(mattmp); 
 free_imatrix_1d(TabGrey); 
}

//----------------------------------------------------------
//  ComputeNumberRegions          
//----------------------------------------------------------
int ComputeNumberRegions(float** mat,int lgth,int wdth)
{
 int i,j,k,l;
 int label;
 int cpt;
 
  //Allocation 
  int** mattmp=imatrix_allocate_2d(lgth,wdth);
  float** matx=fmatrix_allocate_2d(lgth,wdth);
  
  //Init 
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[i][j]=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matx[i][j]=(int)mat[i][j];

  //Boucle
  //-------
  cpt=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     if (mattmp[i][j]==0)
        {
	 label=(int)matx[i][j];
         Paint(matx,mattmp,i,j,lgth,wdth,label);          
         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1) matx[k][l]=cpt;
         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1) mattmp[k][l]=-2;
         cpt++;
        }
 
   //Nombre Regions
   printf("\n >> NbRegions [%d]",cpt);
   fflush(stdout);

 //Liberation 
 free_imatrix_2d(mattmp); 
 free_fmatrix_2d(matx);

 //Retour
 return cpt; 
}


//--------------------------------
//--------------------------------
//---CLEAN------------------------
//--------------------------------
//----------------------------------------------------------
// FuseRegions
//
// < Petite regions inferieur taille sz fusione avec
//    classe majoritaire l entourant >
//              
//----------------------------------------------------------
int FuseSmallRegions(int** mat,int lgth,int wdth,int* nbreg,int sz)
{
 int i,j,k,l,m,n,t;
 float maxim;
 int  labfuse;
 int cpt;
 int initsize;
 int size_min;
 int nbregion_prec;
 int nbregion_init;
 int NbChgt;

 //Allocation 
 int**  mattmp=imatrix_allocate_2d(lgth,wdth);
 float*   claslb=fmatrix_allocate_1d(256);

 //Init 
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]=(int)mat[i][j]; 
 NbChgt=0;

 //Init
 size_min=0;
 nbregion_prec=0;
 cpt=10;
 //printf("\n  FuseSmallRegions[%d]",sz);
 //printf("\n  Regions>");

 //BOUCLE
 //========================================================================
 for(t=0;((t<12)&&(size_min<sz)&&(nbregion_prec!=cpt));t++)
   {

    //Init 
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[i][j]=0;

       //Boucle
       //-------------------------------------
        for(cpt=0,i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (mattmp[i][j]==0)
              {
	       initsize=0;
               Paint(mat,mattmp,i,j,lgth,wdth,(int)mat[i][j]);
               ++cpt;
               for(k=0;k<256;k++)  claslb[k]=0;

               //RegionsVoisines
               for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1)  
	            { initsize++;
                      for(m=-1;m<2;m++) for(n=-1;n<2;n++) 
		        if (((k+m)>=0)&&((k+m)<lgth)&&((l+n)>=0)&&((l+n)<wdth))
		            if (mat[k+m][l+n]<256) claslb[(int)mat[k+m][l+n]]++;  }

               claslb[(int)mat[i][j]]=0;

               //ClasseVoisineMajoritaire
               labfuse=0;
               maxim=0;
               for(k=0;k<256;k++) if (claslb[k]>maxim) { maxim=claslb[k]; labfuse=k; };

               //SiCondition=>Fusion
               if (initsize<=sz)
	          { for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1)
                    mat[k][l]=labfuse; 
                    NbChgt++; }

               for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1) mattmp[k][l]=-2;
	      }//---------------------------

     nbregion_init=cpt;
     size_min=lgth*wdth;
     for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[i][j]=0;

     nbregion_prec=cpt;
     for(cpt=0,i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (mattmp[i][j]==0)
        {
         initsize=0;
         Paint(mat,mattmp,i,j,lgth,wdth,(int)mat[i][j]);
         ++cpt;
 
         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1)  initsize++;

         if (initsize<size_min) size_min=initsize; 

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1) mattmp[k][l]=-2;  
       }

      //printf("(>%d)",cpt);
      (*nbreg)=cpt;
      fflush(stdout);
   }//=====================================================================
 
 //Liberation 
 if (mattmp)  free_imatrix_2d(mattmp); 
 if (claslb)  free_fmatrix_1d(claslb); 

 //Retour
 //printf("   |NbChgt >[%d]",NbChgt);
 return NbChgt;
}

//----------------------------------------------------------
// FuseRegions
//
// < Petite regions inferieur taille sz fusione avec
//    classe majoritaire l entourant >
//
//----------------------------------------------------------
int FuseSmallRegions(float** mat,int lgth,int wdth,int* nbreg,int sz,float elg)
{
 int i,j,k,l,m,n,t;
 float maxim;
 int  labfuse;
 int cpt;
 int initsize;
 int size_min;
 int nbregion_prec;
 int nbregion_init;
 int NbChgt;
 float Elong;
 int nbper;
 int cl;

 //Allocation
 float**  mattmp=fmatrix_allocate_2d(lgth,wdth);
 float*   claslb=fmatrix_allocate_1d(256);

 //Init
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]=(int)mat[i][j];
 NbChgt=0;

 //Init
 size_min=0;
 nbregion_prec=0;
 cpt=10;
 printf("\n  FuseSmallRegions[%d]",sz);
 printf("\n  Regions>");

 //BOUCLE
 //========================================================================
 for(t=0;((t<12)&&(size_min<sz)&&(nbregion_prec!=cpt));t++)
   {

    //Init
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[i][j]=0;

       //Boucle
       //-------------------------------------
        for(cpt=0,i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (mattmp[i][j]==0)
              {
               initsize=0;
               Paint(mat,mattmp,i,j,lgth,wdth,(int)mat[i][j]);
               ++cpt;
               for(k=0;k<256;k++)  claslb[k]=0;

               //RegionsVoisines
               for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1)
                    { initsize++;
                      for(m=-1;m<2;m++) for(n=-1;n<2;n++)
                        if (((k+m)>=0)&&((k+m)<lgth)&&((l+n)>=0)&&((l+n)<wdth))
                            if (mat[k+m][l+n]<256) claslb[(int)mat[k+m][l+n]]++;  }

               claslb[(int)mat[i][j]]=0;

               //ClasseVoisineMajoritaire
               labfuse=0;
               maxim=0;
               for(k=0;k<256;k++) if (claslb[k]>maxim) { maxim=claslb[k]; labfuse=k; };

               //Calcul Elongation
               nbper=0;
               cl=(int)mat[i][j];
               for(k=1;k<(lgth-1);k++) for(l=1;l<(wdth-1);l++) if (mat[k][l]==cl)
                 { if ((mat[k-1][l]!=cl)||(mat[k+1][l]!=cl)||(mat[k][l+1]!=cl)||(mat[k][l-1]!=cl))
                   nbper++; }

               Elong=((4*PI*initsize/CARRE(nbper))*100);
               //printf("<%.3f>",Elong);

               //SiCond. { [Size(region)<sz] || [Elong(region)<elg]] ==> Fusion
               if ((initsize<=sz)||(Elong<=elg))
                  { for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1)
                    mat[k][l]=labfuse;
                    NbChgt++; }

               for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1) mattmp[k][l]=-2;
              }//---------------------------

     nbregion_init=cpt;
     size_min=lgth*wdth;
     for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[i][j]=0;

     nbregion_prec=cpt;
     for(cpt=0,i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (mattmp[i][j]==0)
        {
         initsize=0;
         Paint(mat,mattmp,i,j,lgth,wdth,(int)mat[i][j]);
         ++cpt;

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1)  initsize++;

         if (initsize<size_min) size_min=initsize;

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1) mattmp[k][l]=-2;
       }

      printf("(>%d)",cpt);
      (*nbreg)=cpt;
      fflush(stdout);
   }//=====================================================================

 //Liberation
 if (mattmp)  free_fmatrix_2d(mattmp);
 if (claslb)  free_fmatrix_1d(claslb);

 //Retour
 printf("   |NbChgt >[%d]",NbChgt);
 return NbChgt;
}

//----------------------------------------------------------
// MedianFilter
//----------------------------------------------------------
// MedianFilter
//      voisinage SzN*SzN
//----------------------------------------------------------
void MedianFilter(float** mt,int lgth,int wdth,int SzN) 
{
 int i,j,k,l,m;
 int nb;
 float tmp;

 float** mat_tmp;
 float* vect;

 //reservation memoire
 mat_tmp=fmatrix_allocate_2d(lgth,wdth);
 vect=fmatrix_allocate_1d(SzN*SzN);

 //recopie matrice
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat_tmp[i][j]=mt[i][j];

 //Filtre median
 for(i=(SzN/2);i<(lgth-(SzN/2));i++) for(j=(SzN/2);j<(wdth-(SzN/2));j++)
   {
    nb=0;
    for(k=-(SzN/2);k<=(SzN/2);k++) for(l=-(SzN/2);l<=(SzN/2);l++)  if (!((k==0)&&(l==0)))
        vect[nb++]=mat_tmp[i+k][j+l];

    for(l=0;l<((SzN*SzN)-1);l++) for(m=0;m<((SzN*SzN)-1);m++)
       if (vect[m]>vect[m+1]) 
          { tmp=vect[m];
            vect[m]=vect[m+1];
            vect[m+1]=tmp; } 

   mt[i][j]=vect[((SzN*SzN)/2)]; 
   }

 //liberation memoire
 free_fmatrix_2d(mat_tmp);
 free(vect); 
}

//-------------------------------------------
//-------------------------------------------
//---GESTION SEGMENTATION & VISU CONTOUR-----
//-------------------------------------------
//----------------------------------------------------------*/
// AddContour                               
//----------------------------------------------------------*/
void AddContourImg(float** seg,int*** img,int lgth,int wdth,int gross) 
{
 int i,j,k,l;
 float tmp;
 int dep;

 //Init
 dep=(int)(gross/2);

 //AllocationMemoire
 float** mat_tmp=fmatrix_allocate_2d(lgth,wdth);
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat_tmp[i][j]=255.0;

 //Gradient
 for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
   { tmp=sqrt(CARRE(seg[i+1][j]-seg[i][j])+CARRE(seg[i][j+1]-seg[i][j]));
     if (tmp>0) mat_tmp[i][j]=0.0; }

 //Boucle
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (mat_tmp[i][j]==0.0)
      {
       for(k=-dep;k<=dep;k++) for(l=-dep;l<=dep;l++)
	 if (((i+k)>0)&&((i+k)<lgth)&&((j+l)>0)&&((j+l)<wdth))
	  { img[0][i+k][j+l]=0; 
            img[1][i+k][j+l]=0; 
            img[2][i+k][j+l]=0; }
      }    

 //liberation memoire
 free_fmatrix_2d(mat_tmp); 
}

//----------------------------------------------------------*/
// ContourSeg                              
//----------------------------------------------------------*/
void ContourSeg(int** SegIn,int** SegOut,int lgth,int wdth) 
{
 int i,j;
 float tmp;

 //AllocationMemoire
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) SegOut[i][j]=0;

 //Gradient
 for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
   { tmp=sqrt(CARRE(SegIn[i+1][j]-SegIn[i][j])+CARRE(SegIn[i][j+1]-SegIn[i][j]));
     if (tmp>0) SegOut[i][j]=255; }
}

//----------------------------------------------------------*/
// ContourSeg                              
//----------------------------------------------------------*/
void MoyContourSeg(int*** TabSeg,int NbSegs,int** SegMoy,int lgth,int wdth) 
{
 int i,j,k;
 float tmp;
 
 //Loop
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   { for(tmp=0.0,k=0;k<NbSegs;k++) tmp+=TabSeg[k][i][j];
     tmp/=(NbSegs);
     SegMoy[i][j]=(int)tmp; }
}

//----------------------------------------------------------
// ConvertClassRegionInf
//----------------------------------------------------------
void ConvertClassRegionInf(int** MatIn,int** MatOut,int lgth,int wdth)
{
 int i,j,k,l;
 int label;
 int cpt;

  //Allocation
  int** mattmp=imatrix_allocate_2d(lgth,wdth);

  //Init
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
     { mattmp[i][j]=0;
       MatOut[i][j]=0; }
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatIn[i][j]=(int)MatIn[i][j];

  //Boucle
  //-------
  cpt=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     if (mattmp[i][j]==0)
        {
         label=(int)MatIn[i][j];
         Paint(MatIn,mattmp,i,j,lgth,wdth,label);

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++)
           if (mattmp[k][l]==-1) MatOut[k][l]=cpt;

         cpt++;

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++)
           if (mattmp[k][l]==-1) mattmp[k][l]=-2;
        }

  //Compte Regions
  //printf(" [NbReg=%d]",cpt);
  //fflush(stdout);

 //Liberation
 free_imatrix_2d(mattmp);
}

//--------------------------------
//--------------------------------
//---LOW GESTION GCE-BFM----------
//--------------------------------
//--------------------------------
//----------------------------------------------------------
// NumberRegionMax
//----------------------------------------------------------
int NumberRegionMax(int*** TabSeg,int lgth,int wdth,int NbSegs)
{
 int i,j,k;
 int MaxRegions;
 int IndxSegMaxReg;
 
 MaxRegions=0;
 IndxSegMaxReg=-1;
 for(k=0;k<NbSegs;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
 if (TabSeg[k][i][j]>MaxRegions) { MaxRegions=TabSeg[k][i][j]; IndxSegMaxReg=k; }
 
 MaxRegions++;
 //printf("\n  >> [%d:::MaxNumberRegions=%d]",IndxSegMaxReg,MaxRegions);

 return MaxRegions;
}

//----------------------------------------------------------
// NumberRegionMax
//----------------------------------------------------------
int NumberRegionMax(int** TabSeg,int lgth,int wdth)
{
 int i,j;
 int MaxRegions;
 
 MaxRegions=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
 if (TabSeg[i][j]>MaxRegions)  MaxRegions=TabSeg[i][j]; 
 
 MaxRegions++;
 //printf("\n  >> [NumberRegions=%d]",MaxRegions);

 return MaxRegions;
}

//----------------------------------------------------------
// int Classify
//----------------------------------------------------------
void Classify(int*** TabMatReg,int lgth,int wdth,int nb,float* TabVoI,int FlagVisu)
{
 int k;

 //>MemoryAllocation
 int***  TabSeg=imatrix_allocate_3d(nb,lgth,wdth);
 float** Tab2DVoI=fmatrix_allocate_2d(nb,2);

 //>Init
 for(k=0;k<nb;k++) { Tab2DVoI[k][0]=TabVoI[k]; Tab2DVoI[k][1]=k; }
 sort(Tab2DVoI,0,nb,2);

 //>Info
 //for(k=0;k<nb;k++) printf("\n  [%d...%.0f::%.2f]",k,Tab2DVoI[k][1],Tab2DVoI[k][0]);
 if (FlagVisu)
   { printf("\n  >> ");
     for(k=0;k<nb;k++) printf("[%.3f]",Tab2DVoI[k][0]);
     fflush(stdout); }
 
 //>OutputRes
 for(k=0;k<nb;k++) CopyMat(TabSeg[k],TabMatReg[(int)(Tab2DVoI[k][1])],lgth,wdth);
 for(k=0;k<nb;k++) CopyMat(TabMatReg[k],TabSeg[k],lgth,wdth);
 for(k=0;k<nb;k++) TabVoI[k]=Tab2DVoI[k][0];

 //FreeMemory 
 if (TabSeg)   free_imatrix_3d(TabSeg,nb);
 if (Tab2DVoI) free_fmatrix_2d(Tab2DVoI);
}

//----------------------------------------------------------------
//  quickSort
//  ---------     Arr[l][c]   :: Arr[l][0] a classer
//                            :: l \in [beg::end]
//                            :: c \in [0::Nb]
//----------------------------------------------------------------
void sort(float** arr,int beg,int end,int Nb)
{
 int k;

 //>Sort
 if (end>beg+1)
  {
    float piv=arr[beg][0];
    int l=beg+1,r=end;
    while (l<r)
    {
      if (arr[l][0]<=piv) l++;  
      else { r--; for(k=0;k<Nb;k++) swap(&arr[l][k],&arr[r][k]); }
    }
    l--; for(k=0;k<Nb;k++) swap(&arr[l][k],&arr[beg][k]);
    sort(arr,beg,l,Nb);
    sort(arr,r,end,Nb);
  }
} 

void swap(float* a,float* b)
{
  float t=*a; *a=*b; *b=t;
}

//----------------------------------------------------------
// Complexity
//----------------------------------------------------------   
float Complexity(int*** img,int lgth,int wdth,int div,int SzW)
{
 int i,j,k,l;
 int posr,posc;
 int NbParam;
 float divis;
 int lab;
 float nrj;

 //>Record
 NbParam=div*div*div; 
 divis=(256.0/(float)div);   
 
 //AllocMemoire
 float*** SquWin=fmatrix_allocate_3d(3,SzW,SzW);
 float*   MatHisMoy=fmatrix_allocate_1d(NbParam);
 float*** MatHis=fmatrix_allocate_3d(NbParam,lgth,wdth);

  //Initialization
  for(k=0;k<NbParam;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatHis[k][i][j]=0; 

  //-------------------------------------------------------------
  //RecupLocalHistoMoy  [div][SzW] 
  //-------------------------------------------------------------     
  //printf("\n\n   [Recup Histos Moy...]");
  //fflush(stdout);   
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
    {
     for(k=0;k<SzW;k++) for(l=0;l<SzW;l++) 
        { posr=i-(SzW/2)+k;
          posc=j-(SzW/2)+l;

          if (posr<0)           posr+=lgth;
          if (posr>(lgth-1))    posr-=lgth;  
          if (posc<0)           posc+=wdth;
          if (posc>(wdth-1))    posc-=wdth;

          SquWin[0][k][l]=img[0][posr][posc];
          SquWin[1][k][l]=img[1][posr][posc];
          SquWin[2][k][l]=img[2][posr][posc]; }
   
     for(k=0;k<SzW;k++) for(l=0;l<SzW;l++)  
	{ lab=((int)(SquWin[0][k][l]/divis))*(div*div);
          lab+=((int)(SquWin[1][k][l]/divis))*(div);  
          lab+=((int)(SquWin[2][k][l]/divis)); 
   
          MatHis[(int)(lab)][i][j]++; 
          MatHisMoy[(int)(lab)]++; }

     for(k=0;k<NbParam;k++) MatHis[k][i][j]/=(SzW*SzW);
    }
  for(k=0;k<NbParam;k++) MatHisMoy[k]/=(lgth*wdth*SzW*SzW);
 //-----------------------------------------------------------

 //---------------------------------------------------
 //Boucle---------------------------------------------
 //---------------------------------------------------
 printf("\n  > ComplexityImage ");
 fflush(stdout);
 nrj=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
   for(k=0;k<NbParam;k++) nrj+=fabs(MatHis[k][i][j]-MatHisMoy[k]);

 nrj/=(lgth*wdth*2);
 //-------------------------------------------------

  //Liberation Memoire
  if (SquWin)    free_fmatrix_3d(SquWin,3);
  if (MatHis)    free_fmatrix_3d(MatHis,NbParam);
  if (MatHisMoy) free_fmatrix_1d(MatHisMoy);

 //Retour
  return nrj;
}

//----------------------------------------------------------
// ChangeMetaPixel
//----------------------------------------------------------
void ChangeMetaPixel(int** SegTmp1,int** SegTmp2,int** MatReg,int RegNb,int Lab2,int lgth,int wdth)
{
 int i,j;

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   { if (MatReg[i][j]==RegNb) SegTmp2[i][j]=Lab2;
     else SegTmp2[i][j]=SegTmp1[i][j]; }
} 

//----------------------------------------------------------
// AllocateRegionSeg : AllocateRegionSeg[NbSegs][NbReg][2][x]
//----------------------------------------------------------
int**** AllocateRegionSeg2(int*** TabMatReg,int lgth,int wdth,int NbSegs)
{
 int i,j,k,l,m,n;
 int NbRegMaxTabSeg;
 int cpt;
 int**** StructReg;

 //Info
 printf("\n  >> StructRegionTabSegmentation<version2>[NbSegs=%d]\n",NbSegs);
 fflush(stdout);

 //EstimParam
 NbRegMaxTabSeg=NumberRegionMax(TabMatReg,lgth,wdth,NbSegs);

 //AllocationMemory
 int*  NbRegMaxTab=imatrix_allocate_1d(NbSegs);
 int*  HistoPropReg=imatrix_allocate_1d(NbRegMaxTabSeg);

 //AllocPointeur
 for(l=0;l<NbSegs;l++) NbRegMaxTab[l]=NumberRegionMax(TabMatReg[l],lgth,wdth); 
 StructReg=new int***[NbSegs];
 for(l=0;l<NbSegs;l++) StructReg[l]=new int**[NbRegMaxTab[l]];
 
 //LOOP===================================
 for(l=0;l<NbSegs;l++)
    {
     //printf("\n");
     for(k=0;k<NbRegMaxTab[l];k++) HistoPropReg[k]=0;    
     for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  HistoPropReg[TabMatReg[l][i][j]]++;
     for(k=0;k<NbRegMaxTab[l];k++) StructReg[l][k]=imatrix_allocate_2d(2,(HistoPropReg[k]+1));
     //for(k=0;k<NbRegMaxTab[l];k++) printf("<%d>",HistoPropReg[k]); 

     for(k=0;k<NbRegMaxTab[l];k++) for(n=0;n<2;n++) 
     for(m=0;m<(HistoPropReg[k]+1);m++) StructReg[l][k][n][m]=-1;

     for(k=0;k<NbRegMaxTab[l];k++) 
       { cpt=0;
         for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (TabMatReg[l][i][j]==k)
	   { StructReg[l][k][1][cpt]=i;
             StructReg[l][k][0][cpt]=j;
             cpt++; } }  
    }//=End_LOOP==========================

 //Debug
 if (0)
 for(cpt=0;;cpt++)
    { i=StructReg[1][0][1][cpt];
      j=StructReg[1][0][0][cpt]; 
      if ((i==-1)||(j==-1)) break;
      printf("\n [%d:%d]",i,j); 
      fflush(stdout); }
 
 //FreeMemory
 if (NbRegMaxTab)  free_imatrix_1d(NbRegMaxTab);
 if (HistoPropReg) free_imatrix_1d(HistoPropReg);

 //Retour
 return StructReg;
}



//----------------------------------------------------------
//  ComputeMatClustKClustKp     :: Seg_k=Mat  
//                              :: P_k,k' ou  Card[C_k Inter C_k']
//----------------------------------------------------------
void CompMatClustKClustKp(int*** TabMat,int** Mat,int lgth,int wdth,int NbSegs,int*** PropClust,int NbRegMax)
{
 int i,j,k,l,m;

 //Init
 for(k=0;k<NbSegs;k++) for(l=0;l<NbRegMax;l++) for(m=0;m<NbRegMax;m++) 
 PropClust[k][l][m]=0;

 //Estimator
 for(k=0;k<NbSegs;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
 PropClust[k][Mat[i][j]][TabMat[k][i][j]]++; 
}

//----------------------------------------------------------
//  ComputeMatClustKClustKp     :: Seg_k=Mat  
//                              :: P_k,k' ou  Card[C_k Inter C_k']
//----------------------------------------------------------
void CompMatClustKClustKp(unsigned char*** TabMat,int** Mat,int lgth,int wdth,int NbSegs,int*** PropClust,int NbRegMax)
{
 int i,j,k,l,m;

 //Init
 for(k=0;k<NbSegs;k++) for(l=0;l<NbRegMax;l++) for(m=0;m<NbRegMax;m++) 
 PropClust[k][l][m]=0;

 //Estimator
 for(k=0;k<NbSegs;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
 PropClust[k][Mat[i][j]][TabMat[k][i][j]]++; 
}

//----------------------------------------------------------
//  ComputeMatClustKpClustK     :: Seg_k=Mat  
//                              :: P_k',k ou  Card[C_k' Inter C_k]
//----------------------------------------------------------
void CompMatClustKpClustK(int*** TabMat,int** Mat,int lgth,int wdth,int NbSegs,int*** PropClust,int NbRegMax)
{
 int i,j,k,l,m;

 //Init
 for(k=0;k<NbSegs;k++) for(l=0;l<NbRegMax;l++) for(m=0;m<NbRegMax;m++) 
 PropClust[k][l][m]=0;

 //Estimator
 for(k=0;k<NbSegs;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
 PropClust[k][TabMat[k][i][j]][Mat[i][j]]++; 
}

//----------------------------------------------------------
//  ComputePropClustKprime :: P_k' ou Card(C_k')
//----------------------------------------------------------
void CompPropClustKprime(int*** TabMat,int** PropClust,int lgth,int wdth,int NbSegs,int NbRegMax)
{
 int i,j,k,l;
 
 //Init
 for(k=0;k<NbSegs;k++) for(l=0;l<NbRegMax;l++) PropClust[k][l]=0; 

 //Estimator
 for(k=0;k<NbSegs;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
 PropClust[k][TabMat[k][i][j]]++;
}

//----------------------------------------------------------
//  ComputePropClust :: P_k ou Card(C_k)
//
//----------------------------------------------------------
void CompPropClustK(int* PropClust,int** Mat,int lgth,int wdth,int NbRegMax)
{
 int i,j,k;

 //Init
 for(k=0;k<NbRegMax;k++) PropClust[k]=0;

 //Estimator
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  PropClust[Mat[i][j]]++;
}

//--------------------------------
//--------------------------------
//---MEDIUM GESTION GCE-BFM-------
//--------------------------------
//--------------------------------
//----------------------------------------------------------
// Prior Entropique
//----------------------------------------------------------
float EntropyPrior(int* PropClustK,int NbRegMaxSeg,float Size,float LogMeanReg)
{
 int k;
 float tmp;
 float PriorEntrop=0.0;

 //Boucle
 for(k=0;k<NbRegMaxSeg;k++) 
   { tmp=PropClustK[k]/Size;
     if (tmp) PriorEntrop-=tmp*log2(tmp); }

 PriorEntrop=fabs(PriorEntrop-LogMeanReg);

 //Return
 return PriorEntrop;
}

//----------------------------------------------------------
// FM_SelectSegMapGCE
//----------------------------------------------------------
int FM_SelectSegMapGCE(int*** TabMatReg,int lgth,int wdth,int NbSegs,float* TabDist,float* Dist,float regul,float LOGMEANREG)
{
 int k;
 float MinMoyDist,DistMoy;
 int IndxMinMoyDist;

 //>MemoryAllocation
 int**   MatInt=imatrix_allocate_2d(lgth,wdth);

 //LOOP
 MinMoyDist=10000;
 IndxMinMoyDist=-1;
 for(k=0;k<NbSegs;k++)
   { //>Info
     //printf("\n  [nb::%d]",k);
     //fflush(stdout);
     CopyMat(MatInt,TabMatReg[k],lgth,wdth);
     DistMoy=FM_ComputeGCE(MatInt,TabMatReg,lgth,wdth,NbSegs,regul,LOGMEANREG); 
     TabDist[k]=DistMoy;
     if (DistMoy<MinMoyDist) { MinMoyDist=DistMoy; IndxMinMoyDist=k; } 
   }

 //Record
 (*Dist)=MinMoyDist;

 //FreeMemory 
 if (MatInt) free_imatrix_2d(MatInt);

 //Info
 printf("\n  >> Select[%d::GCE=%.3f]",IndxMinMoyDist,MinMoyDist); 

 //Return
 return IndxMinMoyDist;
}

//----------------------------------------------------------
// CompNbRegions 
//----------------------------------------------------------
int FM_CompNbRegions(int* PropClustK,int NbRegMaxSeg)
{
 int k;
 int NbReg;
 
 //Boucle
 for(NbReg=0,k=0;k<NbRegMaxSeg;k++) if (PropClustK[k]>(SIZEMIN/2)) NbReg++;

 //DEBUG
 if (0)
 for(NbReg=0,k=0;k<NbRegMaxSeg;k++) if (PropClustK[k]>(SIZEMIN/2))
 printf("[%d::%d]",k,PropClustK[k]);
 
 //Retour
 return NbReg;
}

//--------------------------------
//--------------------------------
//-----HIGH GESTION GCE-BFM-------
//--------------------------------
//--------------------------------
//----------------------------------------------------------
// FM_ComputeGCE <version optimise>
//----------------------------------------------------------
float FM_ComputeGCE(int** MatReg,int*** TabMatReg,int lgth,int wdth,int NbSegs,float regul,float LOGMEANREG)
{
 int i,j,k;
 int LabS,LabSp;
 int PropS,PropSp,PropSSp;
 float GCE;
 float LRE1,LRE2;
 float Lre1Loc,Lre2Loc;
 float tmp1,tmp2;
 int   NbRegMaxSeg,NbRegMaxTabSeg;
 float NrjPrior;
 float Size;
 
 //Init
 Size=lgth*wdth;

 //EstimationParam
 NbRegMaxSeg=NumberRegionMax(MatReg,lgth,wdth);
 NbRegMaxTabSeg=NumberRegionMax(TabMatReg,lgth,wdth,NbSegs);
 
 //>MemoryAllocation
 int*    PropClustK=imatrix_allocate_1d(NbRegMaxTabSeg);
 int**   PropClustKp=imatrix_allocate_2d(NbSegs,NbRegMaxTabSeg);
 int***  MatClustKClustKp=imatrix_allocate_3d(NbSegs,NbRegMaxTabSeg,NbRegMaxTabSeg);

 //Compute [P_k]:[P_k']:[P_k_k']
 CompPropClustK(PropClustK,MatReg,lgth,wdth,NbRegMaxSeg);
 CompPropClustKprime(TabMatReg,PropClustKp,lgth,wdth,NbSegs,NbRegMaxTabSeg);
 CompMatClustKClustKp(TabMatReg,MatReg,lgth,wdth,NbSegs,MatClustKClustKp,NbRegMaxTabSeg);

 //LOOP==================================
 LRE1=LRE2=0.0;
 //>Loop[Pixels]
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   {
     LabS=MatReg[i][j];
     PropS=PropClustK[LabS]; 
     
     Lre1Loc=Lre2Loc=0.0; 
     //>Loop[Segmentations]
     for(k=0;k<NbSegs;k++)
       {
	 LabSp=TabMatReg[k][i][j];
         PropSp=PropClustKp[k][LabSp]; 
         PropSSp=MatClustKClustKp[k][LabS][LabSp];

         tmp1=tmp2=0.0;
         if (PropS)  tmp1=(((float)PropS-(float)PropSSp)/(float)PropS);
         if (PropSp) tmp2=(((float)PropSp-(float)PropSSp)/(float)PropSp);

         Lre1Loc+=tmp1;
         Lre2Loc+=tmp2;
       }
     
   LRE1+=Lre1Loc;
   LRE2+=Lre2Loc;    

   }//==End_Loop==========================

 //Compute-GCE
 //GCE=MIN(LRE1,LRE2); 
 GCE=0.50*(LRE1+LRE2);
 GCE/=(NbSegs*Size);

 //PriorEntropy
 NrjPrior=EntropyPrior(PropClustK,NbRegMaxSeg,Size,LOGMEANREG);

 //FreeMemory
 if (PropClustK)       free_imatrix_1d(PropClustK);
 if (PropClustKp)      free_imatrix_2d(PropClustKp);
 if (MatClustKClustKp) free_imatrix_3d(MatClustKClustKp,NbSegs);

 //Likelihood+Prior
 GCE=GCE+(regul*NrjPrior);
 return GCE;
}

//----------------------------------------------------------
// FM_ComputeGCESupPix_1
//----------------------------------------------------------
float FM_ComputeGCESupPix_1(int** MatReg,unsigned char*** TabMatReg,int lgth,int wdth,int NbSegs,float regul,\
int* PropClustK,int** PropClustKp,int*** MatClustKClustKp,int NbRegMaxTabSeg,float LOGMEANREG)
{
  int i,j,k,l,m;
 int LabS,LabSp;
 int PropS,PropSp,PropSSp;
 float GCE;
 float LRE1,LRE2;
 float Lre1Loc,Lre2Loc;
 float tmp1,tmp2;
 int   NbRegMaxSeg;
 float NrjPrior;
 float Size;
 
 //Cst&Init
 const int SCALE=1;
 Size=lgth*wdth;

 //EstimationParam
 NbRegMaxSeg=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (MatReg[i][j]>NbRegMaxSeg)  NbRegMaxSeg=MatReg[i][j];
 NbRegMaxSeg++;

 //Compute [P_k]:[P_k_k']
 for(k=0;k<NbRegMaxSeg;k++) PropClustK[k]=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  PropClustK[MatReg[i][j]]++;

 for(k=0;k<NbSegs;k++) for(l=0;l<NbRegMaxTabSeg;l++) for(m=0;m<NbRegMaxTabSeg;m++) 
 MatClustKClustKp[k][l][m]=0;

 for(k=0;k<NbSegs;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
 MatClustKClustKp[k][MatReg[i][j]][TabMatReg[k][i][j]]++;
 

 //LOOP==================================
 LRE1=LRE2=0.0;
 //>Loop[Pixels]
 for(i=0;i<lgth;i+=SCALE) for(j=0;j<wdth;j+=SCALE)
   {
     LabS=MatReg[i][j];
     PropS=PropClustK[LabS]; 
     
     Lre1Loc=Lre2Loc=0.0; 
     //>Loop[Segmentations]
     for(k=0;k<NbSegs;k++)
       {
	 LabSp=TabMatReg[k][i][j];
         PropSp=PropClustKp[k][LabSp]; 
         PropSSp=MatClustKClustKp[k][LabS][LabSp];

         tmp1=tmp2=0.0;
         if (PropS)  tmp1=(((float)PropS-(float)PropSSp)/(float)PropS);
         if (PropSp) tmp2=(((float)PropSp-(float)PropSSp)/(float)PropSp);

         Lre1Loc+=tmp1;
         Lre2Loc+=tmp2;
       }
     
   LRE1+=Lre1Loc;
   LRE2+=Lre2Loc;    

   }//==End_Loop==========================

 //Compute-GCE
 //GCE=MIN(LRE1,LRE2); 
 GCE=0.50*(LRE1+LRE2);
 GCE/=(NbSegs*Size);
 GCE*=SCALE*SCALE;

 //PriorEntropy
 NrjPrior=EntropyPrior(PropClustK,NbRegMaxSeg,Size,LOGMEANREG);

 //Likelihood+Prior
 GCE=GCE+(regul*NrjPrior);
 return GCE;
}


//----------------------------------------------------------
// FM_ComputeGCESupPix_2 
//----------------------------------------------------------
float FM_ComputeGCESupPix_2(unsigned char** MatRegOld,unsigned char** MatRegNew,unsigned char*** TabMatReg,int lgth,int wdth,int NbSegs,float regul,\
int* PropClustK,int** PropClustKp,int*** MatClustKClustKp,int NbRegMaxTabSeg,int* PropClustK_,int*** MatClustKClustKp_,\
int SegNb,int RegNb,int LabNb,int**** MatRegTabSeg,int SCALE,float LOGMEANREG)
{
  int i,j,k;
 int LabS,LabSp;
 int PropS,PropSp,PropSSp;
 float GCE;
 float LRE1,LRE2;
 float Lre1Loc,Lre2Loc;
 float NrjPrior;
 float Size;
 int row,col;
 int cpt;

 
 //Init&PreCalcul
 //==============
 Size=lgth*wdth;
 for(k=0;k<NbRegMaxTabSeg;k++) PropClustK_[k]=PropClustK[k];
 for(k=0;k<NbSegs;k++) for(i=0;i<NbRegMaxTabSeg;i++) for(j=0;j<NbRegMaxTabSeg;j++) MatClustKClustKp_[k][i][j]=MatClustKClustKp[k][i][j];

 //Prend du temps!!!!!
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatRegNew[i][j]=MatRegOld[i][j];
 //memcpy(MatRegNew,MatRegOld,lgth*wdth);
 
 //Update[PropClustK_][MatClustKClustKp_]
 for(cpt=0;;cpt++)
   { row=MatRegTabSeg[SegNb][RegNb][1][cpt];
     col=MatRegTabSeg[SegNb][RegNb][0][cpt];
     if ((row==-1)||(col==-1)) break;
     MatRegNew[row][col]=LabNb;    

     PropClustK_[MatRegOld[row][col]]--;
     PropClustK_[LabNb]++;
     for(k=0;k<NbSegs;k++) 
       { MatClustKClustKp_[k][MatRegOld[row][col]][TabMatReg[k][row][col]]--;
         MatClustKClustKp_[k][LabNb][TabMatReg[k][row][col]]++; } }


 //======================================
 //LOOP==================================
 LRE1=LRE2=0.0;
 //>Loop[Pixels]
 for(i=0;i<=(lgth-SCALE);i+=SCALE) for(j=0;j<=(wdth-SCALE);j+=SCALE)
   {
     LabS=MatRegNew[i][j];
     PropS=PropClustK_[LabS]; 
     
     Lre1Loc=Lre2Loc=0.0; 
     //>Loop[Segmentations]
     for(k=0;k<NbSegs;k++)
       {
	 LabSp=TabMatReg[k][i][j];
         PropSp=PropClustKp[k][LabSp]; 
         PropSSp=MatClustKClustKp_[k][LabS][LabSp];

         if (PropS)  Lre1Loc+=(((float)PropS-(float)PropSSp)/(float)PropS);
         if (PropSp) Lre2Loc+=(((float)PropSp-(float)PropSSp)/(float)PropSp);
       }     
   LRE1+=Lre1Loc;
   LRE2+=Lre2Loc;    

   }//==End_Loop==========================

 //Compute-GCE
 //GCE=MIN(LRE1,LRE2); 
 GCE=0.50*(LRE1+LRE2);
 GCE/=(NbSegs*Size);

 //PriorEntropy
 NrjPrior=EntropyPrior(PropClustK_,NbRegMaxTabSeg,Size,LOGMEANREG);

 //Likelihood+Prior
 GCE=GCE+(regul*NrjPrior);

 //Return
 return GCE;
}


//----------------------------
//   ICM ---------------------
//----------------------------
//----------------------------------------------------------
//----------------------------------------------------------
// FM_ICM_GCE_SupPix
//---------------------------------------------------------- 
//----------------------------------------------------------
void FM_ICM_GCESupPix(int** MatRegIn,int** MatRegOut,int*** TabMatReg,int lgth,int wdth,\
int NbSegs,int NbIter,float regul,int SCALE,float LOGMEANREG)
{
  int i,j,k,l,m; 
 int NbRegMaxSeg,NbRegMaxTabSeg;
 int Lab2;
 int nbchgt,nbhypix,nbregs;
 float nrjprior;
 float nrj1,nrj2;
 float GCE;

 int*  PntPropVct;
 unsigned char** PntMat;
 int*** PntPropTab3d;
 
 //EstimationParam
 NbRegMaxSeg=NumberRegionMax(MatRegIn,lgth,wdth);
 NbRegMaxTabSeg=NumberRegionMax(TabMatReg,lgth,wdth,NbSegs);
 
 //AllocationMemory
 int**  SegTmp1=imatrix_allocate_2d(lgth,wdth);
 int**  SegTmp2=imatrix_allocate_2d(lgth,wdth);
 int**  SegTmp3=imatrix_allocate_2d(lgth,wdth);
 unsigned char** SegTmpS1=cmatrix_allocate_2d(lgth,wdth);
 unsigned char** SegTmpS2=cmatrix_allocate_2d(lgth,wdth);
 int*   NbRegMaxTab=imatrix_allocate_1d(NbSegs);
 int*   PropClustK=imatrix_allocate_1d(NbRegMaxTabSeg);
 int*   PropClustK_=imatrix_allocate_1d(NbRegMaxTabSeg);
 int**  PropClustKp=imatrix_allocate_2d(NbSegs,NbRegMaxTabSeg);
 int*** MatClustKClustKp=imatrix_allocate_3d(NbSegs,NbRegMaxTabSeg,NbRegMaxTabSeg); 
 int*** MatClustKClustKp_=imatrix_allocate_3d(NbSegs,NbRegMaxTabSeg,NbRegMaxTabSeg);
 unsigned char*** TabMatRegC=cmatrix_allocate_3d(NbSegs,lgth,wdth);
 int**** MatRegTabSeg=AllocateRegionSeg2(TabMatReg,lgth,wdth,NbSegs);

 //>Init[PropClustK/K_][MatClustKClustKp/Kp_]
 for(k=0;k<NbRegMaxTabSeg;k++) 
   { PropClustK[k]=0;
     PropClustK_[k]=0; }
 
 for(m=0;m<NbSegs;m++) for(k=0;k<NbRegMaxTabSeg;k++) for(l=0;l<NbRegMaxTabSeg;l++) 
   { MatClustKClustKp[m][k][l]=0;
     MatClustKClustKp_[m][k][l]=0; }

 //><NbRegMaxTab[k]>
 for(k=0;k<NbSegs;k++) NbRegMaxTab[k]=NumberRegionMax(TabMatReg[k],lgth,wdth); 

 //>Compute [P_k']
 CompPropClustKprime(TabMatReg,PropClustKp,lgth,wdth,NbSegs,NbRegMaxTabSeg);

 //>TabMatReg en UnsignedChar
 for(k=0;k<NbSegs;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) TabMatRegC[k][i][j]=TabMatReg[k][i][j];
 
 //>Init
 CopyMat(SegTmp1,MatRegIn,lgth,wdth);
 GCE=FM_ComputeGCESupPix_1(SegTmp1,TabMatRegC,lgth,wdth,NbSegs,regul,PropClustK,PropClustKp,MatClustKClustKp,NbRegMaxTabSeg,LOGMEANREG);
 printf("\n   > FM_ICM_GCE_SupPix[::][NbIter=%d][GCE=%.5f]",NbIter,GCE); 
 printf("\n                      [::][NbSegs=%d][Regul=%.5f][LogMeanReg=%.2f]",NbSegs,regul,LOGMEANREG);
 printf("\n                      [::][NbRegions=%d][NbRegionsTab=%d]",NbRegMaxSeg,NbRegMaxTabSeg);
 printf("\n                      [::][Scale=%d]",SCALE);
 fflush(stdout);

  //====================================================================
  //ICM_GCE_SupPix  [MatRegIn >>> MatRegOut]
  //====================================================================
  for(k=0;k<NbIter;k++)
     {
      CopyMat(SegTmp3,SegTmp1,lgth,wdth);
      CopyMat(SegTmpS1,SegTmp1,lgth,wdth);
      nrj1=GCE;

      //-----------------------------------------------------------
      // Loop Img > Loop MetaPixels[TabMatReg]
      //------------------------------------------------------------
       nbhypix=0;
       for(i=0;i<NbSegs;i++) for(j=0;j<NbRegMaxTab[i];j++)
          {
           //[Lab1](NoChange])&[Lab2]  
           Lab2=(int)((NbRegMaxTabSeg/2.0)*randomize());
           nrj2=FM_ComputeGCESupPix_2(SegTmpS1,SegTmpS2,TabMatRegC,lgth,wdth,NbSegs,regul,PropClustK,PropClustKp,MatClustKClustKp,NbRegMaxTabSeg,PropClustK_,MatClustKClustKp_,i,j,Lab2,MatRegTabSeg,SCALE,LOGMEANREG);
           

           //nrj1>nrj2
           if (nrj1>nrj2) { nrj1=nrj2;
		            nbhypix++;                          
                                
                            //CopyMat(SegTmpS1,SegTmpS2,lgth,wdth);
                            PntMat=SegTmpS1;     
                            SegTmpS1=SegTmpS2;   
                            SegTmpS2=PntMat;     
             
                            //CompPropClustK(PropClustK,SegTmpS1,lgth,wdth,NbRegMaxTabSeg); 
                            PntPropVct=PropClustK;
                            PropClustK=PropClustK_;
                            PropClustK_=PntPropVct;

                            //CompMatClustKClustKp(TabMatReg,SegTmp1,lgth,wdth,NbSegs,MatClustKClustKp,NbRegMaxTabSeg); 
                            PntPropTab3d=MatClustKClustKp;
                            MatClustKClustKp=MatClustKClustKp_;
                            MatClustKClustKp_=PntPropTab3d; }

             }//End_Loop_SuperPixel------------------------------------------  

          //>Info
          CopyMat(SegTmp1,SegTmpS1,lgth,wdth); 
          GCE=FM_ComputeGCESupPix_1(SegTmp1,TabMatRegC,lgth,wdth,NbSegs,regul,PropClustK,PropClustKp,MatClustKClustKp,NbRegMaxTabSeg,LOGMEANREG);
	  //if ((k>20)&&(GCE_old<=GCE)) break;  
          nbchgt=DiffMatNb(SegTmp3,SegTmp1,lgth,wdth);
          nbregs=FM_CompNbRegions(PropClustK,NbRegMaxTabSeg);
          nrjprior=regul*EntropyPrior(PropClustK,NbRegMaxTabSeg,lgth*wdth,LOGMEANREG);
          printf("\n  [%d]>%.5f  [NbChgt:%d][NbHypPix:%d][NbRegions:%d][NrjPrior:%.5f]",k,GCE,nbchgt,nbhypix,nbregs,nrjprior);
          fflush(stdout); 

         }//End_ICM_GCE_SupPix================================================
  
 //Nrj_finale[ImgRes] 
 CopyMat(MatRegOut,SegTmp1,lgth,wdth);
 GCE=FM_ComputeGCESupPix_1(MatRegOut,TabMatRegC,lgth,wdth,NbSegs,regul,PropClustK,PropClustKp,MatClustKClustKp,NbRegMaxTabSeg,LOGMEANREG);
 printf("\n   >> [NrjGCE::%.5f]",GCE);
 nrjprior=EntropyPrior(PropClustK,NbRegMaxTabSeg,lgth*wdth,0.0);
 printf("\n   >> [Prior2::%.5f]",nrjprior);

 
 //FreeMemory
 if (SegTmp1)           free_imatrix_2d(SegTmp1); 
 if (SegTmp2)           free_imatrix_2d(SegTmp2); 
 if (SegTmp3)           free_imatrix_2d(SegTmp3); 
 if (SegTmpS1)          free_cmatrix_2d(SegTmpS1);
 if (SegTmpS2)          free_cmatrix_2d(SegTmpS2);
 if (NbRegMaxTab)       free_imatrix_1d(NbRegMaxTab); 
 if (PropClustK)        free_imatrix_1d(PropClustK);
 if (PropClustK_)       free_imatrix_1d(PropClustK_);
 if (PropClustKp)       free_imatrix_2d(PropClustKp);
 if (MatClustKClustKp)  free_imatrix_3d(MatClustKClustKp,NbSegs);
 if (MatClustKClustKp_) free_imatrix_3d(MatClustKClustKp_,NbSegs);
 if (TabMatRegC)        free_cmatrix_3d(TabMatRegC,NbSegs);
}


//--------------------------------//
//--------------------------------//
//--- TEST------------------------//
//--------------------------------//
//--------------------------------//
//----------------------------------------------------------
//  SaveImage3dPgm                      
//----------------------------------------------------------                
void SaveImage3dPgm(char* path,char* name,int*** mat,int lgth,int wdth,int nb)
{
 int i,j,k;
 char buff[300];
 FILE* fic;
 int   LgthBigImg;

  //--extension--
  strcpy(buff,path);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--Memory---
  LgthBigImg=lgth*nb;
  int** MatImg=imatrix_allocate_2d(LgthBigImg,wdth);
  for(i=0;i<LgthBigImg;i++) for(j=0;j<wdth;j++) MatImg[i][j]=0;

  //--Load-----
  for(k=0;k<nb;k++)
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatImg[i+(k*lgth)][j]=mat[k][i][j];

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
  printf("\n  >> Sauvegarde de %s au format pgm",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",wdth,LgthBigImg);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<LgthBigImg;i++) for(j=0;j<wdth;j++) 
	fprintf(fic,"%c",(char)MatImg[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 

  //Liberation Memoire
  if (MatImg) free_imatrix_2d(MatImg);
}

//----------------------------------------------------------
//  LoadImage3dPgm        
//----------------------------------------------------------
void LoadImage3dPgm(char* path,char* name,int*** Mat3D,int lgth,int wdth,int nb)
 {
   int i,j,k;
  int temp;
  char buff[300];
  char* tempc;
  unsigned char var;
  char stringTmp1[200],stringTmp2[200];
  int ta1,ta2,ta3;
  FILE *fic;
  int   LgthBigImg;

  //--extension--
  strcpy(buff,path);
  strcat(buff,name);
  //strcat(buff,".pgm");

  //--Memory---
  LgthBigImg=lgth*nb;
  int** MatImg=imatrix_allocate_2d(LgthBigImg,wdth);
  for(i=0;i<LgthBigImg;i++) for(j=0;j<wdth;j++) MatImg[i][j]=0;

  //enregistrement du chemin;
   if (strstr(buff,".pgm")==NULL) strcat(buff,".pgm");

   //ouverture du fichier
  fic=fopen(buff,"r");
  if (fic==NULL) 
   { printf("\n ->> Grave erreur a l'ouverture de %s -\n",path);
     exit(-1); }

  //recuperation de l'entete
  tempc=fgets(stringTmp1,100,fic); //P5
  tempc=fgets(stringTmp2,100,fic); //Comment
  temp=fscanf(fic," %d %d",&ta1,&ta2);
  temp=fscanf(fic," %d\n",&ta3);

  //affichage de l'entete
  printf("\n\n -- Entete --");
  printf("\n ------------");
  printf("\n %s  %d %d \n %d",stringTmp1,ta1,ta2,ta3);
  printf("\n");
   
  //chargement dans la matrice
  for(i=0;i<LgthBigImg;i++) for(j=0;j<wdth;j++)  
    { temp=fread(&var,1,1,fic);
      MatImg[i][j]=var; }

  for(k=0;k<nb;k++) 
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Mat3D[k][i][j]=MatImg[i+(k*lgth)][j];

  //Liberation Memoire
  if (MatImg) free_imatrix_2d(MatImg);   

  //fermeture du fichier
  fclose(fic);
 }

//----------------------------------------------------------
// RandomImgVert
//----------------------------------------------------------   
void RandomImgVert(int** Img,int lgth,int wdth,int nbcl)
{
 int i,j,k,l;
 int cpt;
 int WdthStripe=(int)(wdth/nbcl);

 //Init
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Img[i][j]=(nbcl-1);

 //Fill
 cpt=0;
 for(k=0;k<(wdth-WdthStripe);k+=WdthStripe)
   { for(l=0;l<WdthStripe;l++) for(i=0;i<lgth;i++) Img[i][k+l]=cpt;
     cpt++; }
}

//----------------------------------------------------------
// RandomImgHor
//----------------------------------------------------------   
void RandomImgHor(int** Img,int lgth,int wdth,int nbcl)
{
 int i,j,k,l;
 int cpt;
 int LgthStripe=(int)(lgth/nbcl);

 //Init
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Img[i][j]=(nbcl-1);

 //Fill
 cpt=0;
 for(k=0;k<(lgth-LgthStripe);k+=LgthStripe)
   { for(l=0;l<LgthStripe;l++) for(j=0;j<wdth;j++) Img[k+l][j]=cpt;
     cpt++; }
}
