//------------------------------------------------------
// module  : FunctionFMFBM.h
// auteur  : Lazhar Khelifi and Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <new>
#include <time.h>
#include <sys/resource.h>
#include "GCEBFM.h"

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define PI  3.14159
#define GREY_LEVEL 255
#define BIGNUMBER 100000000
#define TROIS 3
#define NCHAR 200

#define CARRE(X) ((X)*(X))
#define MAX(a,b)   (((a)>(b))?(a):(b))
#define MIN(a,b)   (((a)>(b))?(b):(a))

//------------------------------------------------
// FunctionGCEBFM.cc
//------------------------------------------------
//>MatrixAllocation
float*            fmatrix_allocate_1d(int);
float**           fmatrix_allocate_2d(int,int);
float***          fmatrix_allocate_3d(int,int,int);
int*              imatrix_allocate_1d(int);
int**             imatrix_allocate_2d(int,int);
int***            imatrix_allocate_3d(int,int,int);
int****           imatrix_allocate_4d(int,int,int,int);
unsigned char*    cmatrix_allocate_1d(int);
unsigned char**   cmatrix_allocate_2d(int,int);
unsigned char***  cmatrix_allocate_3d(int,int,int);
void  free_fmatrix_1d(float*);
void  free_fmatrix_2d(float**);
void  free_fmatrix_3d(float***,int);
void  free_imatrix_1d(int*);
void  free_imatrix_2d(int**);
void  free_imatrix_3d(int***,int);
void  free_imatrix_3d(int****,int,int);
void  free_cmatrix_1d(unsigned char*);
void  free_cmatrix_2d(unsigned char**);
void  free_cmatrix_3d(unsigned char***,int);

//>MatrixGestion
void  CopyMat(int**,int**,int,int);
void  CopyMat(int**,float**,int,int);
void  CopyMat(float**,int**,int,int);
void  CopyMat(unsigned char**,int**,int,int);
void  CopyMat(int**,unsigned char**,int,int);
void  Recal(float**,int,int); 
void  Recal(int**,int,int);
int   DiffMatNb(int**,int**,int,int);

//>Random
float randomize(void);

//>File
void GetLengthWidth(char*,int*,int*);
void load_image_ppm(char*,int***,int,int);
void SaveImagePgm(char*,char*,float**,int,int);
void SaveImagePgm(char*,char*,int**,int,int);
void SaveImagePgm(char*,char*,unsigned char**,int,int);
void SaveImagePpm(char*,char*,int***,int,int); 
void SaveImagePpm(char*,char*,float***,int,int); 
void SaveTabImagePgm(char*,char*,int***,int,int,int);

//>SpaceColor
void RGBToHSV(float,float,float,float*,float*,float*);
void RGBToYIQ(float,float,float,float*,float*,float*);
void RGBToXYZ(float,float,float,float*,float*,float*);
void XYZToRGB(float,float,float,float*,float*,float*);
void RGBToLAB(float,float,float,float*,float*,float*);
void RGBToLUV(float,float,float,float*,float*,float*);
void RGBToI1I2I3(float,float,float,float*,float*,float*);
void RGBToH1H2H3(float,float,float,float*,float*,float*);
void RGBToHSL(float,float,float,float*,float*,float*);
void RGBToTSL(float,float,float,float*,float*,float*);
void RGBToYCbCr(float,float,float,float*,float*,float*);
void RGBToP1P2(float,float,float,float*,float*,float*);

//>Kmean
int  Identical(int*,int**,int,int);
void KmeanFast(int**,int,int,int,int*,int,int);
void SegmentationHistoCOLORKmeanFast(int***,int**,int,int,int,int,int,int,int);

//>FusionRegions
void Paint(int**,int**,int,int,int,int,int);
void Paint(float**,float**,int,int,int,int,int);
void ConvertClassRegion(float**,int,int);
int  ComputeNumberRegions(float**,int,int);

//>Clean
int  FuseSmallRegions(int**,int,int,int*,int);
int  FuseSmallRegions(float**,int,int,int*,int,float);
void MedianFilter(float**,int,int,int);

//>GestionSegmentation&VisuContour
void AddContourImg(float**,int***,int,int,int);
void ContourSeg(int**,int**,int,int);
void MoyContourSeg(int***,int,int**,int,int); 
void ConvertClassRegionInf(int**,int**,int,int);

//>LowGestion[GCE-BFM]
int   NumberRegionMax(int***,int,int,int);
int   NumberRegionMax(int**,int,int);
void  Classify(int***,int,int,int,float*,int);
void  sort(float**,int,int,int);
void  swap(float*,float*); 
float Complexity(int***,int,int,int,int);
void  ChangeMetaPixel(int**,int**,int**,int,int,int,int);
int**** AllocateRegionSeg2(int***,int,int,int);
void CompMatClustKClustKp(int***,int**,int,int,int,int***,int);
void CompMatClustKClustKp(unsigned char***,int**,int,int,int,int***,int);
void CompMatClustKpClustK(int***,int**,int,int,int,int***,int);
void CompPropClustKprime(int***,int**,int,int,int,int);
void CompPropClustK(int*,int**,int,int,int);

//>MediumGestion[GCE-BFM]
float EntropyPrior(int*,int,float,float);
int   FM_SelectSegMapGCE(int***,int,int,int,float*,float*,float,float);
int   FM_CompNbRegions(int*,int);

//>HighGestion[GCE-BFM]
float FM_ComputeGCE(int**,int***,int,int,int,float,float);

float FM_ComputeGCESupPix_1(int**,unsigned char***,int,int,int,float,int*,int**,int***,int,float);
float FM_ComputeGCESupPix_2(unsigned char**,unsigned char**,unsigned char***,int,int,int,float,int*,int**,int***,int,int*,short int***,int,int,int,int****,int,float);
  
//>ICM_[GCE-BFM]
void  FM_ICM_GCESupPix(int**,int**,int***,int,int,int,int,float,int,float);

//>TEST
void SaveImage3dPgm(char*,char*,int***,int,int,int);
void LoadImage3dPgm(char*,char*,int***,int,int,int);
void RandomImgVert(int**,int,int,int);
void RandomImgHor(int**,int,int,int);
