//---------------------------------------------------
// module  : GCEBFM.h                         
// auteur  : Lazhar Khelifi and Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

#ifndef GCEBFM_H
#define GCEBFM_H

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionGCEBFM.h"

//------------------------------------------------
// CONSTANTES  -----------------------------------
//------------------------------------------------

//>MODEL SEGMENTATIONS
const int NBSPCOL=12; 

const int NBCL1=11;  
const int NBCL2=9;
const int NBCL3=3;    

const int NBINS=5;
const int NBINSGRAD=10;
const int SIZE1=7;
const int SIZEMIN=200;

//> MODEL PRIOR
const float REGULALPHA=0.010;
const float LOG_MEAN_REG=4.2;

//>MODEL FUSION
const int NBITERICM=8; 
const int PRECIS=2;

//>MODEL VISU
const int ZOOM=1;
const int SAVE=1;
const int VISU=1;
const int QUIT=0;


//------------------------------------------------
// CLASSE GCEBFM ----------------------------------
//------------------------------------------------
class GCEBFM
{
  //--Donnees--
  //-----------
  public:

  //Matrices Img
  int***    mat_img;
  int***    mat_cnt;
  float**   mat_seg; 

  //ParamIMG
  int width,length;
  float RegulAlpha;
  float LogMeanReg;

  //Flag
  int  flag_save;
  int  flag_visu;

  //Utile
  char Name_Sauve[NCHAR];
  char Name_Img[NCHAR];
  char Extension[NCHAR];  

  //--Methodes--
  //------------
  public:
  GCEBFM(int***,int,int);
  ~GCEBFM();

  //Fonction
  void MultipleSegmentations(int***,int,int,int,int);

  //GCE-Fusion
  void GCEFusionModel();
  //====================================
  
};

#endif 
